package favi;

import idx3d.idx3d_Light;
import idx3d.idx3d_Material;
import idx3d.idx3d_Math;
import idx3d.idx3d_Object;
import idx3d.idx3d_ObjectFactory;
import idx3d.idx3d_Scene;
import idx3d.idx3d_Texture;
import idx3d.idx3d_TextureFactory;
import idx3d.idx3d_Vector;
import idx3d.idx3d_Vertex;

//import java.awt.Button;
import java.awt.Color;
import java.awt.Dimension;
//import java.awt.Event;
import java.awt.Graphics;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.event.MouseWheelListener;
import java.awt.event.MouseWheelEvent;
import javax.swing.JPanel;

import jGDK.Framstick;
import jGDK.Library;
import jGDK.Record;
import jGDK.FramstickListener;
import jGDK.FramstickEvent;

import java.util.Hashtable;
import jGDK.I18N;
/**
 * This class is responsible for organisms body visualisation.
 * It uses idx3d package designed by Peter Walser to create simple 3D scene.
 * @author Marcin Jurkiewicz
 * @version 1.32
 */
public class Tazo extends JPanel implements MouseListener, MouseMotionListener, Zoomable //, MouseWheelListener
{
  MyFramstickListener mFL = new MyFramstickListener();
  public Framstick fram;
  static int[] standardNeuron =
  {1,4,70,50,50,50,20,80,20,20,50,50};
  
  static Hashtable map = new Hashtable();
  
  public idx3d_Scene scene;	//podstawowa zmienna dla trybu graficznego :)
  int oldx=0;			//na podstawie tych dwoch zmiennych i polozenia myszki
  int oldy=0;			//bedziemy manipulowac scena
  float centralPoint[] =
  { 0, 0, 0 };	//srodek do centrowania modelu
  float aquariumSize[] =
  { 0, 0, 0 }; //do box'a i zasiegu kamery
  float maxPoint[] =
  { 0, 0, 0 }; //max i min wsp. modelu w kazdym wymiarze
  float minPoint[] =
  { 0, 0, 0 };
  public idx3d_Material markedS = new idx3d_Material(0x00ff00);
  public idx3d_Material markedW = new idx3d_Material(0x00bb00);
  public idx3d_Material markedS2 = new idx3d_Material(0x550000);
  public idx3d_Material markedW2 = new idx3d_Material(0xff7777);
  public idx3d_Material color = new idx3d_Material(0x00cccccc);
  public idx3d_Material color1 = new idx3d_Material(0x00cccccc);
  public idx3d_Material black = new idx3d_Material(0x0022);
  public idx3d_Material zielony1 = new idx3d_Material(0xB612);		//trzy zielone
  public idx3d_Material zielony2 = new idx3d_Material(0x9A41);		//kolorki
  public idx3d_Material zielony3 = new idx3d_Material(0x8512);		//najciemniejszy
  public idx3d_Material zolty = new idx3d_Material(0xD2FA15);		//do wchlaniania
  public idx3d_Material friction = new idx3d_Material(idx3d_TextureFactory.CHECKERBOARD(120,120,2,0x8512,0xB612));
  public idx3d_Material assimilation = new idx3d_Material(0xB600);
  public float view = 0;						//pozycja kamery
  boolean boxOnScene = true;			//czy rysujemy akwarium
  public boolean autorotation = false;		//czy obraz sie obraca
  String rotationDirection = null;	//i w jakim kierunku
  boolean wires = false;				//czy siatka
  public boolean details = false;			//szczegoly widoczne lub nie
  boolean niceBackground = false;		//tlo szare albo niebo
  int oldSizeX = 0;					//rozmiary okna
  int oldSizeY = 0;					//dla zmiany rozmiarow sceny
  Dimension d;						//wymiary okna
  public String markedObject = null;			//obiekt zaznaczony
  boolean redrawNet = false;			//czy trzeba tekturowac tlo
  public String description1 = null;			//do opisu w dole ekranu
  public String description2 = null;
  public boolean addingJoint = false;		//informuje, czy wlasnie dodajemy jointa
  public boolean addingPart = false;			//j.w. z Partami
  public boolean translating = false;		//czy jestesmy w trybie przesuwania zaznaczonych elementow
  public int partAddingFlag = 0;				//z ktorego kierunku dodajemy Parta(ktora plaszczyzna)
  public int translatingFlag = 0;			//na ktorej plaszczyznie dokonujemy translacji
  boolean shiftPressed = false;		//czy w danej chwili wcisniety jest klawisz Shift
  boolean controlPressed = false;		//czy w danej chwili wcisniety jest klawicz Ctrl
  
  //licznik neuronow umieszczonych na scenie
  public int licznikNeuronow = 0;
  
  idx3d_Texture tlo4 = idx3d_TextureFactory.SKY(400,400,3);//domyslne tlo
  idx3d_Texture tlo5 = idx3d_TextureFactory.SKY(500,500,3);
  idx3d_Texture tlo6 = idx3d_TextureFactory.SKY(600,600,3);
  
  /**
   * Constructor is responsible fop initialization of idx3d package.
   * It imports information about organism and prepares 3d scene for drawing.
   */
  public Tazo(Framstick model)
  {
    fram = model;
    fram.addFramstickListener(mFL);//jarzbi
    //		createTextures();	//CD	//tworzenie tekstur symboli neuronow
    buildCenter();				//budujemy srodek sceny (tam kierujemy kamere)
    prepareScene();				//podstawowe ustawienia sceny
    createLights();				//utworzenie zrodel swiatla
    addObjectsToScene();		//dodanie obiektow do sceny
    redrawScene();			    //zeby od razu wysrodkowalo
                /*Button button1 = new Button("Zoom in "); //rozmieszczenie przyciskow
        add(button1);
                Button button2 = new Button("Zoom out");
                add(button2);
                Button button3 = new Button("   Box  ");
                add(button3);
                Button button4 = new Button("Default ");
                add(button4);
                Button button5 = new Button("Rotation");
                add(button5);
                Button button6 = new Button("Details ");
                add(button6);
                Button button7 = new Button(" Wires  ");
                add(button7);
                Button button8 = new Button(" Delete ");
                add(button8);
                Button button9 = new Button(" Undo ");
                add(button9);
                Button button10 = new Button(" Redo ");
                add(button10);
                Button button11 = new Button(" AddJ ");
                add(button11);
                Button button12 = new Button("AddPFront");//dodawanie Parta na plaszczyznie XY
                add(button12);
                Button button13 = new Button("AddPSide");//ZY
                add(button13);
                Button button14 = new Button("AddPPlan");//XZ
                add(button14);
                 */
    this.addMouseListener(this);
    this.addMouseMotionListener(this);
    try
    {
    if (Class.forName("java.awt.event.MouseWheelListener")!=null)
	this.addMouseWheelListener(new WheelZoomer(this));
    } catch(Exception ex) {}
//    this.addMouseWheelListener(this);
    this.setMinimumSize(new Dimension(40,40));
  }
  
  //----- wywolywana za kazdym razem, gdy zawartosc okna musi zostac ponownie wyswietlona
  
  /**
   * Updates the screen content.
   */
  public void paint(Graphics g)
  {
    update(g);
  }
  
  //----- wywolywana, gdy applet zada ponownego wyswietlenia fragmentu jego okna
  
  /**
   * Method responsible for rendering objects to scene.
   */
  public void update(Graphics g)
  {
    d = getSize();								//pobiera rozmiar appletu
    if (d.width!=oldSizeX || d.height!=oldSizeY)//jesli dawne rozmiary sa
    {											//inne niz aktualne
      oldSizeX = d.width;						//to zapamietuje rozmiar apletu
      oldSizeY = d.height;
      scene.resize(oldSizeX, oldSizeY-22);	//i dopasowuje rozmiar sceny
    }											//do wymiarow okna
    if (autorotation)//jesli wlaczono obracanie
    {	//to obracamy
      if(rotationDirection.equals("X"))
      {
        scene.rotate(idx3d_Math.pi/45,0,0);
      }
      else if(rotationDirection.equals("Y"))
      {
        scene.rotate(0,idx3d_Math.pi/45,0);
      }
      else if(rotationDirection.equals("Z"))
      {
        scene.rotate(0,0,idx3d_Math.pi/45);
      }
      else if(rotationDirection.equals("R"))
      {
        float dx=(float)Math.sin((float)System.currentTimeMillis()/1000)/15;
        float dy=(float)Math.cos((float)System.currentTimeMillis()/1000)/15;
        scene.rotate(dx,dy,0);//that was OK
      }
      repaint();
    }
    if(niceBackground)
    {
      updateBackground();						//jesli cos zaznaczone, to neuroniki wyswietlamy
    }
    else
    {
      //scene.environment.setBackground(null);//tlo
      //scene.setBackgroundColor(0xF2E7D9);//tlo
    }
    g.setColor(new Color(0x000000ff));		//wypelnia na niebiesko
    g.fillRect(0,d.height-22,d.width,d.height);//prostokat w dole ekranu
    if(description1!=null)
    {
      g.setColor(new Color(0x00ffffff));		//a na bialo wypisuje
      g.drawString(description1,10,d.height-12);//opis zaznaczonego neuronu
      g.drawString(description2,10,d.height-2);
    }
    scene.render();							//renderuje scene do bufora
    g.drawImage(scene.getImage(),0,0,null);	//wyswietla otrzymany obraz
  }
  
  //----- procedura tworzaca scene i ustalajaca jej podstawowe parametry
  
  /**
   * This method is setting basic parameters of 3D scene rendered in idx3d package,
   * like material parameters, background color and camera positioning.
   */
  public void prepareScene()
  {
    scene=new idx3d_Scene(this.getSize().width,this.getSize().height-22);//scena
    scene.setAntialias(true);//zeby bylo ladnie
    scene.useIdBuffer(true);		//do identyfikacji obiektow
    //scene.environment.setBackground(tlo4);//tlo
    scene.setBackgroundColor(0xaaaaaa);//F2E7D9);//tlo
    friction.setReflectivity(0);//od szortskiego swiatlo sie nie odbija
    assimilation.setReflectivity(50);//od fotocostam tez sie nie odbija
    zielony1.setWireframe(true);
    zielony1.setTransparency(255);
    color1.setWireframe(true);
    color1.setTransparency(255);
    defaultCameraPos();//ustalenie domyslnej pozycji kamery
  }
  
  //----- tutaj z kolei zajmiemy sie parametrami swiatel
  /**
   * This method sets lights color and direction.
   */
  public void createLights()
  {
    scene.addLight("Light1",new idx3d_Light(new idx3d_Vector(0.2f,0.2f,1f),0xFFFFFF,320,120));
    scene.addLight("Light2",new idx3d_Light(new idx3d_Vector(-1f,-1f,1f),0xFFCC99,160,200));
  }
  
  //-- tworzenie obiektow, dodawanie ich do sceny, ustalenie materialu i pozycji obiektow
  
  /**
   * This method is drawing an organism and otker elements of the scene.
   */
  public void addObjectsToScene()
  {
    for(int i=0; i<fram.getPartCount(); i++)
    {//dodajemy party
      drawPart(i, ((Float)fram.getPartProp(i,"x")).floatValue(), ((Float)fram.getPartProp(i,"y")).floatValue(), ((Float)fram.getPartProp(i,"z")).floatValue());	//[wiersz][kolumna]
    }
    for(int i=0; i<fram.getJointCount(); i++)
    {//jointy
      drawJoint(i, ((Integer)fram.getJointProp(i,"p1")).intValue(), ((Integer)fram.getJointProp(i,"p2")).intValue());
    }
    drawAquarium();//i akwarium
    if(markedObject!=null && markedObject.startsWith("Neuron"))
    {//na wypadek usuniecia ostatniego z neuronow w innym oknie
      int id = Integer.valueOf(markedObject.substring(6,markedObject.length()-2)).intValue();
      if(scene.object("Neuron"+id+"__")==null)
      {
        description1="";
        markedObject=null;
        return;
      }
    }
    if(markedObject!=null) drawDescription();//zaznaczenie elementu
  }
  
  /**
   * This method is drawing a single Part and visualisating its parameters.
   */
  public void drawPart(int i, float x, float y, float z)//rysuje part :)
  {
    //promien zalezny od masy
    float liczba = ((Float)fram.getPartProp(i,"m")).floatValue();
    if (liczba>30) liczba=30;
    float radius = 0.1f * (float)Math.pow(liczba/0.1f,1f/3f);
    idx3d_Object part = idx3d_ObjectFactory.SPHERE(radius,10);//kula
    scene.addObject("Part" + i + "____",part);				  //id
    if(details) scene.object("Part" + i + "____").setMaterial(zielony3);
    else scene.object("Part" + i + "____").setMaterial(color);
    //jesli element mocno zaznaczony, to ustawiamy jego kolorek na jasniejszy
    if(fram.elementStrongSelected("p",i))
    {
      if(details)	scene.object("Part" + i + "____").setMaterial(markedS);
      else scene.object("Part" + i + "____").setMaterial(markedS2);
    }//kula robocza dla teksturek i siatek
    idx3d_Object part1 = idx3d_ObjectFactory.SPHERE(radius-0.01f,10);//kula
    scene.addObject("Part" + i + "___*",part1);				        //id
    if(details) scene.object("Part" + i + "___*").setMaterial(zielony3);
    else scene.object("Part" + i + "___*").setMaterial(color);
    //ustawienie koloru teksturki tez jest konieczne
    if(fram.elementStrongSelected("p",i))
    {
      if(details)	scene.object("Part" + i + "___*").setMaterial(markedS);
      else scene.object("Part" + i + "___*").setMaterial(markedS2);
    }
    part1.setPos(x, y, z);//no i wspolrzedne parta
    if(details)
    {
      //kolorek - jezeli tarcie nieco powyzej normy to teksturka
      if(((Float)fram.getPartProp(i,"fr")).floatValue() >=0.5f) scene.object("Part" + i + "____").setMaterial(friction);
      //ponowne ustawienie kolorku, coby tarcie nie przykrylo zaznaczenia
      if(fram.elementStrongSelected("p",i))
      {
        if(details) scene.object("Part" + i + "____").setMaterial(markedS);
        else scene.object("Part" + i + "____").setMaterial(markedS2);
      }
      //wchlanianie - jedziemy teraz z zoltymi kuleczkami
      //liczba kuleczek zalezy od wartosci czynnika wchlanianie
      int noOfBalls = (int)Math.floor(((Float)fram.getPartProp(i,"ing")).floatValue()/0.04f);
      float ballx = 0;//wspolrzedne kuleczki
      float bally = 0;
      float ballz = 0;
      if(noOfBalls>80) noOfBalls=80;//zeby nazwa byla jednolita liczba dwucyfrowa
      for(int j=10; j<(noOfBalls+10); j++)//X losowo rozmieszczonych receptorow
      {//x i y losujemy, a z obliczamy tak, by receptor lezal na parcie
        ballx = x - radius + (float)Math.random()*(2*radius);
        bally = y - radius + (float)Math.random()*(2*radius);
        ballz = (float)Math.sqrt(radius*radius-(x-ballx)*(x-ballx)-(y-bally)*(y-bally)) + z;
        idx3d_Object ball = idx3d_ObjectFactory.SPHERE(0.05f,6);//assymil.
        scene.addObject("Part" + i + "_" + j + "1", ball);
        scene.object("Part" + i + "_" + j + "1").setMaterial(zolty);
        ball.setPos(ballx, bally, ballz);//ustawiamy wchlaniacz
        ballx = 2*x - ballx;//i obliczamy wspolrzedne
        bally = 2*y - bally;//symetrycznego do niego wzgl. srodka parta
        ballz = 2*z - ballz;//zeby po obu stronach bylo rownomiernie
        idx3d_Object ball1 = idx3d_ObjectFactory.SPHERE(0.05f,6);//assymil.2
        scene.addObject("Part" + i + "_" + j +"2", ball1);
        scene.object("Part" + i + "_" + j + "2").setMaterial(zolty);
        ball1.setPos(ballx, bally, ballz);
      }
      //asymilacja - po przekroczeniu progu 0.5f nakladamy dodatkowa teksturke
      if(((Float)fram.getPartProp(i,"as")).floatValue() >= 0.5f)
      {	//kula o promieniu wiekszym o 0.01 - zeby byla widoczna
        idx3d_Object more = idx3d_ObjectFactory.SPHERE(radius+0.01f,10);//kula
        scene.addObject("Part" + i + "__##",more);						//id
        scene.object("Part" + i + "__##").setMaterial(assimilation);
        //jak zwykle - dodatkowa zmiana koloru, zeby zaznaczenie bylo widoczne
        if(fram.elementStrongSelected("p",i))
        {
          if(details) scene.object("Part" + i + "__##").setMaterial(markedS);
          else scene.object("Part" + i + "__##").setMaterial(markedS2);
        }
        more.setPos(x,y,z);
      }
    }//if(details)
    part.setPos(x, y, z);//no i wspolrzedne parta
  }
  
  /**
   * This method is drawing a single Joint and visualisating its parameters.
   */
  public void drawJoint(int i, int p1, int p2)//rysuje joint
  {
    float x1 = ((Float)fram.getPartProp(p1,"x")).floatValue();//wsp. 3D laczonych partow
    float x2 = ((Float)fram.getPartProp(p2,"x")).floatValue();
    float y1 = ((Float)fram.getPartProp(p1,"y")).floatValue();
    float y2 = ((Float)fram.getPartProp(p2,"y")).floatValue();
    float z1 = ((Float)fram.getPartProp(p1,"z")).floatValue();
    float z2 = ((Float)fram.getPartProp(p2,"z")).floatValue();
    float dist_x = x2 - x1;//roznice we wsp.
    float dist_y = y2 - y1;
    float dist_z = z2 - z1;
    float centr_x = (x1 + x2)/2;//srodek dla kazdej ze wsp.
    float centr_y = (y1 + y2)/2;
    float centr_z = (z1 + z2)/2;
    float length = 0;
    if (dist_y != 0) length = dist_y;		//os y
    else if (dist_x != 0) length = dist_x;  //os x
    else length = dist_z;					//os z
    idx3d_Object joint = idx3d_ObjectFactory.CYLINDER(length,0.1f,10);
    scene.addObject("Joint" + i + "__",joint);//obiekt, id, kolor
    if(details) scene.object("Joint" + i+ "__").setMaterial(zielony2);
    else scene.object("Joint" + i+ "__").setMaterial(color);
    //kolory parta przy zaznaczeniu byly zmieniane, joint nie moze byc gorszy
    if(fram.elementWeakSelected("j",i))
    {
      if(details) scene.object("Joint" + i + "__").setMaterial(markedW);
      else scene.object("Joint" + i+ "__").setMaterial(markedW2);
    }
    if(fram.elementStrongSelected("j",i))
    {
      if(details) scene.object("Joint" + i + "__").setMaterial(markedS);
      else scene.object("Joint" + i+ "__").setMaterial(markedS2);
    }
    float dx = 0, dz = 0;
    if (dist_y!=0)
    {
      dx = dist_x/dist_y;
      dz = dist_z/dist_y;
    }
    else if (dist_x!=0) dz = dist_z/dist_x;
    else dx = dist_x/dist_z;
    for(int j = 0; j < joint.vertexData.size(); j++)
    {
      idx3d_Vertex v = (idx3d_Vertex) joint.vertexData.elementAt(j);
      v.pos.x += dx * v.pos.y;
      v.pos.z += dz * v.pos.y;
    }
    if(dist_y==0)
    {
      if(dist_x!=0) joint.rotate(0, 0, idx3d_Math.pi/2);  //os x
      else joint.rotate(idx3d_Math.pi/2, 0, 0);		    //os z
    }
    joint.setPos(centr_x, centr_y, centr_z);	//umieszczenie cylindra to jego srodek
    if(details)
    {
      //jointy towarzyszace - poboczna nazwijmy to
      float howStrong = 0.01f + ((Float)fram.getJointProp(i,"stam")).floatValue()/(100*0.25f);//ich srednica zalezy
      if(howStrong>0.08f) howStrong=0.08f;			   //od wartosci staminy
      idx3d_Object joint1 = idx3d_ObjectFactory.CYLINDER(length,howStrong,10);
      scene.addObject("Joint" + i + "_1",joint1);//obiekt, id, kolor
      scene.object("Joint" + i + "_1").setMaterial(zielony2);
      for(int j = 0; j < scene.object("Joint" + i + "_1").vertexData.size(); j++)
      {//kazdy jest tworzony, nazywany, kolorowany i obracany oddzielnie
        idx3d_Vertex v1 = (idx3d_Vertex) scene.object("Joint" + i + "_1").vertexData.elementAt(j);
        v1.pos.x += dx * v1.pos.y + 0.1f;
        v1.pos.z += dz * v1.pos.y;
      }
      idx3d_Object joint2 = idx3d_ObjectFactory.CYLINDER(length,howStrong,10);
      scene.addObject("Joint" + i + "_2",joint2);//obiekt, id, kolor
      scene.object("Joint" + i + "_2").setMaterial(zielony2);
      for(int j = 0; j < scene.object("Joint" + i + "_2").vertexData.size(); j++)
      {//kazdy jest tworzony, nazywany, kolorowany i obracany oddzielnie
        idx3d_Vertex v2 = (idx3d_Vertex) scene.object("Joint" + i + "_2").vertexData.elementAt(j);
        v2.pos.x += dx * v2.pos.y - 0.1f;
        v2.pos.z += dz * v2.pos.y;
      }
      idx3d_Object joint3 = idx3d_ObjectFactory.CYLINDER(length,howStrong,10);
      scene.addObject("Joint" + i + "_3",joint3);//obiekt, id, kolor
      scene.object("Joint" + i + "_3").setMaterial(zielony2);
      for(int j = 0; j < scene.object("Joint" + i + "_3").vertexData.size(); j++)
      {//kazdy jest tworzony, nazywany, kolorowany i obracany oddzielnie
        idx3d_Vertex v3 = (idx3d_Vertex) scene.object("Joint" + i + "_3").vertexData.elementAt(j);
        v3.pos.x += dx * v3.pos.y;
        v3.pos.z += dz * v3.pos.y + 0.1f;
      }
      idx3d_Object joint4 = idx3d_ObjectFactory.CYLINDER(length,howStrong,10);
      scene.addObject("Joint" + i + "_4",joint4);//obiekt, id, kolor
      scene.object("Joint" + i + "_4").setMaterial(zielony2);
      for(int j = 0; j < scene.object("Joint" + i + "_4").vertexData.size(); j++)
      {//kazdy jest tworzony, nazywany, kolorowany i obracany oddzielnie
        idx3d_Vertex v4 = (idx3d_Vertex) scene.object("Joint" + i + "_4").vertexData.elementAt(j);
        v4.pos.x += dx * v4.pos.y;
        v4.pos.z += dz * v4.pos.y - 0.1f;
      }
      for(int z=1; z<5; z++)
      {//wszystkie sa obracane w ten sam sposob i umieszczane w tym samym punkcie
        if(dist_y==0)
        {
          if(dist_x!=0) scene.object("Joint" + i + "_" + z).rotate(0, 0, idx3d_Math.pi/2);  //os x
          else scene.object("Joint" + i +  "_" + z).rotate(idx3d_Math.pi/2, 0, 0);	//os z
        }
        scene.object("Joint" + i + "_" + z).setPos(centr_x, centr_y, centr_z);	//umieszczenie cylindra to jego srodek
      }
    }//if(details)
  }
  
  /**
   * This method is drawing a box inside which the framstick is presented.
   */
  public void drawAquarium()//rysuje box'a
  {
    float xMin = minPoint[0] - 0.5f;	float xMax = maxPoint[0] + 0.5f;
    float yMin = minPoint[1] - 0.5f;	float yMax = maxPoint[1] + 0.5f;
    float zMin = minPoint[2] - 0.5f;	float zMax = maxPoint[2] + 0.5f;
    float corners[][] =
    {
      { xMin, yMin, zMin },
      { xMax, yMin, zMin },
      { xMax, yMin, zMax },
      { xMin, yMin, zMax },
      { xMin, yMax, zMin },
      { xMax, yMax, zMin },
      { xMax, yMax, zMax },
      { xMin, yMax, zMax } };
      int lines[][] =
      {
        { 0, 1 },
        { 0, 4 },
        { 0, 3 },
        { 1, 5 },
        { 5, 4 },
        { 5, 6 },
        { 3, 7 },
        { 3, 2 },
        { 2, 6 },
        { 7, 6 },
        { 1, 2 },
        { 4, 7 } };
        for(int i=0; i<8; i++)
        {
          idx3d_Object kula = idx3d_ObjectFactory.SPHERE(0.02f,8);
          scene.addObject("AquariumP" + i, kula);
          kula.setMaterial(black);
          kula.setPos(corners[i][0]-centralPoint[0],corners[i][1]-centralPoint[1],corners[i][2]-centralPoint[2]);
        }
        for(int i=0; i<12; i++)
        {
          float howLong = (float)Math.sqrt((corners[lines[i][0]][0]-corners[lines[i][1]][0])*(corners[lines[i][0]][0]-corners[lines[i][1]][0])+(corners[lines[i][0]][1]-corners[lines[i][1]][1])*(corners[lines[i][0]][1]-corners[lines[i][1]][1])+(corners[lines[i][0]][2]-corners[lines[i][1]][2])*(corners[lines[i][0]][2]-corners[lines[i][1]][2]));
          idx3d_Object linia = idx3d_ObjectFactory.CYLINDER(howLong, 0.01f, 8);
          scene.addObject("AquariumL" + i, linia);
          linia.setMaterial(black);
          if(corners[lines[i][0]][1]==corners[lines[i][1]][1])
            if(corners[lines[i][0]][0]!=corners[lines[i][1]][0])
              linia.rotate(0,0,idx3d_Math.pi/2);
            else
              linia.rotate(idx3d_Math.pi/2,0,0);
          linia.setPos(((corners[lines[i][0]][0]+corners[lines[i][1]][0])/2)-centralPoint[0],((corners[lines[i][0]][1]+corners[lines[i][1]][1])/2)-centralPoint[1],((corners[lines[i][0]][2]+corners[lines[i][1]][2])/2)-centralPoint[2]);
        }
  }
  
  /**
   * This method is removing a box inside which the framstick is presented from the scene.
   */
  public void removeAquarium()
  {
    for(int i=0; i<8; i++) scene.removeObject("AquariumP" + i);
    for(int i=0; i<12; i++) scene.removeObject("AquariumL" + i);
  }
  
  /**
   * This method puts the camera into its default position and sets its default direction.
   */
  public void defaultCameraPos()//poczatkowe ustawienie kamery
  {
    view = (float)Math.sqrt( aquariumSize[0]*aquariumSize[0] + aquariumSize[1]*aquariumSize[1] + aquariumSize[2]*aquariumSize[2] ) + 2;
    scene.defaultCamera.lookAt(0,0,0);
    scene.defaultCamera.setPos(0,0,-view);
  }
  
  /**
   * Moves the camera closer to the organism.
   */
  public void zoomIn()//zblizenie
  {
    if (view>3) view -= 2;
    scene.defaultCamera.setPos(0,0,-view);
    repaint();
  }
  
  /**
   * Moves the camera further from the organism.
   */
  public void zoomOut()//oddalenie
  {
    view += 2;
    scene.defaultCamera.setPos(0,0,-view);
    repaint();
  }
  
  /**
   * Manages the option of placing box on the scene.
   */
  public void boxVisible()//zmiana opcji widocznosci box'a
  {
    if (boxOnScene)
    {
      removeAquarium();
      boxOnScene = false;
    }
    else
    {
      drawAquarium();
      boxOnScene = true;
    }
    scene.rebuild();
    repaint();
  }
  
  /**
   * Manages the option of scene animation. Enables or disables rotation of the organism.
   */
  public void setAutorotation(String option)//zmiana opcji obracania sceny
  {
    if (option.equals("S"))
    {
      autorotation = false;
      scene.setAntialias(true);
    }
    else
    {
      autorotation = true;
      rotationDirection = option;
      scene.setAntialias(false);
    }
    repaint();
  }
  
  /**
   * Manages the option of the presentation of the organism. It is possible to set simple
   * view or view with details, nice looking, but slower.
   */
  public void setDetails()//zmiana opcji widoku - szczegoly widoczne lub nie
  {
    if (details)
    {
      details = false;
      redrawScene();
    }
    else
    {
      details = true;
      redrawScene();
    }
    repaint();
  }
  
  /**
   * Manages the option of the presentation of the background. It is possible to set simple
   * view or view with sky in the background.
   */
  public void setBackground()//zmiana opcji widoku - tlo z neuronami albo szare
  {
    if(niceBackground)
    {
      niceBackground = false;
      scene.environment.setBackground(null);//tlo
      redrawScene();
    }
    else
    {
      niceBackground = true;
      redrawScene();
    }
    repaint();
  }
  
  /**
   * It switches the view option - you can see the organism in normal or wires mode,
   * as a mesh.
   */
  public void setWires()//zmiana opcji widoku - widok siatkowany
  {
    if(!wires)
    {
      color.setWireframe(true);
      color.setTransparency(255);
      markedW.setWireframe(true);
      markedW.setTransparency(255);
      markedS.setWireframe(true);
      markedS.setTransparency(255);
      markedW2.setWireframe(true);
      markedW2.setTransparency(255);
      markedS2.setWireframe(true);
      markedS2.setTransparency(255);
      zielony2.setWireframe(true);
      zielony2.setTransparency(255);
      zielony3.setWireframe(true);
      zielony3.setTransparency(255);
      zolty.setWireframe(true);
      zolty.setTransparency(255);
      friction.setWireframe(true);
      friction.setTransparency(255);
      assimilation.setWireframe(true);
      assimilation.setTransparency(255);
      wires = true;
    }
    else
    {
      color.setWireframe(false);
      color.setTransparency(0);
      markedS.setWireframe(false);
      markedS.setTransparency(0);
      markedW.setWireframe(false);
      markedW.setTransparency(0);
      markedS2.setWireframe(false);
      markedS2.setTransparency(0);
      markedW2.setWireframe(false);
      markedW2.setTransparency(0);
      zielony2.setWireframe(false);
      zielony2.setTransparency(0);
      zielony3.setWireframe(false);
      zielony3.setTransparency(0);
      zolty.setWireframe(false);
      zolty.setTransparency(0);
      friction.setWireframe(false);
      friction.setTransparency(0);
      assimilation.setWireframe(false);
      assimilation.setTransparency(0);
      wires = false;
    }
    repaint();
  }
  
  /**
   * Updates the image of an organism after editing operations.
   */
  public void redrawScene()//przebudowa sceny
  {
    scene.removeAllObjects();
    buildCenter();
    addObjectsToScene();			//ustawiamy default, zeby rysunki sie nie rozlazly
    scene.rebuild();
    for(int i=0; i<scene.objects; i++)
    {
      if(scene.object[i].name.startsWith("Aquarium")) continue;
      if(scene.object[i].name.startsWith("Description")) continue;
      if(scene.object[i].name.startsWith("Neuron")) continue;//neurony, podobnie jak w/w obiekty, nie powinny byc przesuwane
      scene.object[i].shift(-centralPoint[0],-centralPoint[1],-centralPoint[2]);//odznaczenie
    }
    scene.rebuild();				//w koncu scena sie przestawia na default
    if(autorotation) scene.setAntialias(false);
    if(!boxOnScene) removeAquarium();
    redrawNet = true;
    if(niceBackground)
    {
      updateBackground();
    }
    else
    {
      if(markedObject!=null)//ustalamy typ, liczbe neuronow i id obiektu (o ile zaznaczono)
      {
        if(markedObject.startsWith("Part"))
        {
          int id = Integer.valueOf(markedObject.substring(4,markedObject.length()-4)).intValue();
          //((Neuron)MyModel.vNeurons.elementAt(id)).properties.contains("p");
          description1 = "Part" + id + ": m=" + fram.getPartProp(id,"m") + "; fr=" + fram.getPartProp(id,"fr") + "; ing=" + fram.getPartProp(id,"ing") + "; as=" + fram.getPartProp(id,"as") + ";";
          description2 = "Neurons: ";
          for(int i=0; i<fram.getNeuroCount(); i++)
          {
            if(((Integer) fram.getNeuroProp(i,"p")).intValue() == id)
              description2 = description2 + "n" + i +", ";
          }
        }
        else if(markedObject.startsWith("Joint"))
        {
          int id = Integer.valueOf(markedObject.substring(5,markedObject.length()-2)).intValue();
          description1 = "Joint" + id + ": stam=" + fram.getJointProp(id,"stam") + ";";
          description2 = "Neurons: ";
          for(int i=0; i<fram.getNeuroCount(); i++)
          {
            if(((Integer) fram.getNeuroProp(i,"j")).intValue() == id)
              description2 = description2 + "n" + i +", ";
          }
        }
        else if(markedObject.startsWith("Neuron"))//jest neuronem
        {
          int id = Integer.valueOf(markedObject.substring(6,markedObject.length()-2)).intValue();
          String typik = (String)fram.getNeuroProp(id,"d");
          description1 = "Neuron " + id + " (" + typik + ")";
          description2="";
        }
      }
      //scene.environment.setBackground(null);//tlo
      //scene.setBackgroundColor(0xF2E7D9);//tlo
    }
  }
  
  /**
   * Estimates the center coordinates of the organism required for rotations and other transformations.
   */
  public void buildCenter()//budowanie srodka sceny (dla skierowania kamery)
  {
    for(int i=0; i<3; i++)
    {
      maxPoint[i] = Float.NEGATIVE_INFINITY;
      minPoint[i] = Float.POSITIVE_INFINITY;
    }
    for(int i=0; i<fram.getPartCount(); i++)
    {
      if (((Float)fram.getPartProp(i,"x")).floatValue() > maxPoint[0]) maxPoint[0] = ((Float)fram.getPartProp(i,"x")).floatValue();
      if (((Float)fram.getPartProp(i,"y")).floatValue() > maxPoint[1]) maxPoint[1] = ((Float)fram.getPartProp(i,"y")).floatValue();
      if (((Float)fram.getPartProp(i,"z")).floatValue() > maxPoint[2]) maxPoint[2] = ((Float)fram.getPartProp(i,"z")).floatValue();
      if (((Float)fram.getPartProp(i,"x")).floatValue() < minPoint[0]) minPoint[0] = ((Float)fram.getPartProp(i,"x")).floatValue();
      if (((Float)fram.getPartProp(i,"y")).floatValue() < minPoint[1]) minPoint[1] = ((Float)fram.getPartProp(i,"y")).floatValue();
      if (((Float)fram.getPartProp(i,"z")).floatValue() < minPoint[2]) minPoint[2] = ((Float)fram.getPartProp(i,"z")).floatValue();
    }//okreslamy max. wychylone wsp. dla kazdego wymiaru
    this.centralPoint[0] = (minPoint[0] + ((maxPoint[0] - minPoint[0])/2));
    this.centralPoint[1] = (minPoint[1] + ((maxPoint[1] - minPoint[1])/2));
    this.centralPoint[2] = (minPoint[2] + ((maxPoint[2] - minPoint[2])/2));
    //obliczamy srodek dla kazdego wymiaru i rozmiary akwarium
    this.aquariumSize[0] = maxPoint[0] - minPoint[0] + 1;
    this.aquariumSize[1] = maxPoint[1] - minPoint[1] + 1;
    this.aquariumSize[2] = maxPoint[2] - minPoint[2] + 1;
  }
  //-----------------------------------------------------------------------------
  //-----tworzenie tekstur prezentujacych symbole neuronow (dla zaznaczenia)-----
  //-----------------------------------------------------------------------------
  /**
   * The midpointline algorithm implemented to create nerons images on the backround texture
   * when in detailed mode.
   */
  public static void midPointLine(int x0, int y0, int x1, int y1, int[] mapa)
  {//wbrew nazwie jest to podstawowy algorytm przyrostowy
    int x;				//poszerzony o rysowanie linii pionowej
    float dy, dx, y, m;
    dx = x1-x0;//delty
    dy = y1-y0;
    if(x0!=x1)//algorytm przyrostowy
    {
      m=dy/dx;
      y=y0;
      for(x=x0; x<=x1; x++)//idziemy po x i zwiekszamy odpowiednio y
      {					 //czyli ustawiamy mape tekstury
        mapa[x+(int)(Math.floor(y+0.5f))*100] = 0;
        y+=m;
      }
    }
    else//linia pionowa - rysujemy odpowiednie punkty dla stalego x
    {
      y=y0;
      if(y0>y1)//zeby zawsze szlo w gore
      {
        y0=y1;
        y1=(int)y;
      }
      for(int i=y0; i<=y1; i++) mapa[x0+(int)(Math.floor(i+0.5f))*100] = 0;
    }
  }
  
  /**
   * Creates the texture image - manages the array containing data.
   */
  public static void createTextures(Library library)		//tworzy teksture z definicji symboli
  {								    //zawartych w tabeli definition
    
    for (int a=0; a < library.database.size(); a++)
    {
      Record record = (Record) library.database.get(a);
      if (!record.sort.equals("neuro")) continue; //CD
      String name = (String) record.getInfoAbout("id");
      int[] scheme = (int[]) record.getInfoAbout("symbol");
      
      if (scheme == null) scheme = standardNeuron;
      int[] mapa = new int[10000];	//mapa tekstur
      
      for(int i=0; i<10000; i++) mapa[i]=255;//"czyscimy"
      int point1x = 0;int point1y = 0;int point2x = 0;int point2y = 0;int position = 0;
      int noOfBlocks = 0;//liczba ciaglych obszarow w definicji
      int noOfLines = 0;//liczba linii w kolejnym obszarze
      noOfBlocks = scheme[position++];//liczba ciaglych obszarow
      for(int i=0; i<noOfBlocks; i++)//dla kazdego bloku
      {		noOfLines = scheme[position++];//liczba linii w obszarze
                point2x = scheme[position++];
                point2y = scheme[position++];
                for(int j=0; j<noOfLines; j++)//dla kazdej linii w bloku
                {		point1x = point2x;	  //rysujemy linie, czyli
                                point1y = point2y;	  //zmieniamy kolor na obszarze tekstury
                                point2x = scheme[position++];
                                point2y = scheme[position++];
                                if(point1x<=point2x)
                                  midPointLine(point1x, point1y, point2x, point2y, mapa);
                                else
                                  midPointLine(point2x, point2y, point1x, point1y, mapa);
                }
      }
      map.put(name, mapa);
    }
  }
  
  /**
   * Visusalisates marking object. Action is performed by clicking mouse. It is also possible
   * to mark objects using Shift and Control keys.
   */
  public void markObject(idx3d_Object obiekt)//zaznaczenie obiektu
  {
    //wszystkie elementy powinny zostac odznaczone
    //ale pod warunkiem, ze nie trzymamy Ctrl
    if((obiekt==null)&&(markedObject==null)) return;//nic nie jest zaznaczone
    //i nic nie zaznaczamy, to nic nie trzeba robic :)
    if(!shiftPressed && !controlPressed)
    {
      for(int i=0; i<fram.getPartCount(); i++)
      {
        if(details) scene.object("Part" + i + "____").setMaterial(zielony3);
        else scene.object("Part" + i + "____").setMaterial(color);
        if(details && ((Float)fram.getPartProp(i,"fr")).floatValue() >=0.5f && scene.object("Part" + i + "____")!=null) scene.object("Part" + i + "____").setMaterial(friction);
        if(details && ((Float)fram.getPartProp(i,"as")).floatValue() >=0.5f && scene.object("Part" + i + "__##")!=null) scene.object("Part" + i + "__##").setMaterial(assimilation);
        fram.unmarkPart(i);
      }
      for(int i=0; i<fram.getJointCount(); i++)
      {
        if(details) scene.object("Joint" + i + "__").setMaterial(zielony3);
        else scene.object("Joint" + i + "__").setMaterial(color);
        fram.unmarkJoint(i);
      }
      //odznaczenie neuronow inaczej przebiega, bo neurony moga miec rozne kolory
      for(int i=0; i<fram.getNeuroCount(); i++)
      {
        if(scene.object("Neuron"+i+"__")==null) continue;
        String zmienna = (String)fram.getNeuroProp(i,"d");
        //String zmienna = fram.getNeuroProp(markedNeuronShort,"d");
        if(zmienna.equals("G")) scene.object("Neuron"+i+"__").setMaterial(new idx3d_Material(0xEEEEEE));//odznaczenie
        else if(zmienna.equals("T")) scene.object("Neuron"+i+"__").setMaterial(new idx3d_Material(0x000000));
        else if(zmienna.equals("S")) scene.object("Neuron"+i+"__").setMaterial(new idx3d_Material(0xFF5500));
        else if(zmienna.equals("@")) scene.object("Neuron"+i+"__").setMaterial(new idx3d_Material(0xFF0000));
        else if(zmienna.equals("|")) scene.object("Neuron"+i+"__").setMaterial(new idx3d_Material(0xFF0000));
        else scene.object("Neuron"+i+"__").setMaterial(new idx3d_Material(0xEEEEE));
        fram.unmarkNeuron(i);
      }
    }
    //jesli zaznaczono inny obiekt, to neurony powinny zniknac
    if(markedObject!=null)//cos bylo zaznaczone
    {
      //a my klikamy w proznie, nie na neuron, lub nie trzymamy Ctrl
      //to usuwamy neurony ze sceny
      if((obiekt==null || !obiekt.name.startsWith("Neuron")) && !shiftPressed && !controlPressed)
      {
        //na wszelki wypadek przelatuje przez cala tablice
        for(int i=0; i<fram.getNeuroCount(); i++)//bo idx miesza z importem
        {
          scene.removeObject("Neuron"+i+"__");
        }
      }
    }
    //usuwanie strzalek
    for(int i=1; i<7; i++)
    {
      scene.removeObject("Description"+i);//to usuwamy ramke
    }
    if(obiekt==null)//jak nie kliknieto na obiekcie
    {
      if(markedObject!=null && !shiftPressed && !controlPressed) //a byl zaznaczony
      {
        //i neurony (znowu dla pewnosci przez cala tablice)
        for(int i=0; i<fram.getNeuroCount(); i++)
        {
          scene.removeObject("Neuron"+i);
        }
        description1 = null;			  //i opis elementu
        description2 = null;
        scene.rebuild();				  //przebudowujemy scene
        markedObject=null;				  //i "odznaczamy" zmienna
        redrawNet = true;
        //trial - powinno byc dla odswiezania ale psuje widok neuronow
        fram.fireSignificantEditEvent();
      }
      return;								  //i nie robimy nic wiecej
    }
    if(obiekt.name.startsWith("Part") || obiekt.name.startsWith("Joint") || obiekt.name.startsWith("Neuron"))
    {//jak zaznaczamy co innego, to przerysowujemy box w innym miejscu
      //zmiana kolorkow odpowiednich obiektow na jasnozielony
      if(obiekt.name.startsWith("Part"))
      {
        int id = Integer.valueOf(obiekt.name.substring(4,obiekt.name.length()-4)).intValue();
        //dla ewentualnego odznaczania elementu z Ctrl
        if(fram.elementStrongSelected("p",id) && controlPressed)
        {
          fram.unmarkPart(id);
          if(details) scene.object("Part" + id + "____").setMaterial(zielony3);
          else scene.object("Part" + id + "____").setMaterial(color);
          if(((Float)fram.getPartProp(id,"as")).floatValue() >= 0.5f && scene.object("Part"+id+"__##")!=null)
          {
            if(details) scene.object("Part" + id + "__##").setMaterial(assimilation);
            else scene.object("Part" + id + "__##").setMaterial(color);
          }
          for(int i=0; i<fram.getJointCount(); i++)
          {
            if(fram.elementStrongSelected("j",i))
            {
              if(details) scene.object("Joint" + i + "__").setMaterial(markedS);
              else scene.object("Joint" + i + "__").setMaterial(markedS2);
            }
            else if(fram.elementWeakSelected("j",i))
            {
              if(details) scene.object("Joint" + i + "__").setMaterial(markedW);
              else scene.object("Joint" + i + "__").setMaterial(markedW2);
            }
            else
            {
              if(details) scene.object("Joint" + i + "__").setMaterial(zielony2);
              else scene.object("Joint" + i + "__").setMaterial(color);
            }
          }
          return;
        }
        //koniec jaj z odznaczaniem
        fram.markPart(id);
        if(details) scene.object("Part" + id + "____").setMaterial(markedS);
        else scene.object("Part" + id + "____").setMaterial(markedS2);
        if(((Float)fram.getPartProp(id,"as")).floatValue() >= 0.5f && scene.object("Part"+id+"__##")!=null)
        {
          if(details) scene.object("Part" + id + "__##").setMaterial(markedS);
          else scene.object("Part" + id + "__##").setMaterial(markedS2);
        }
        for(int i=0; i<fram.getJointCount(); i++)
        {
          if(fram.elementWeakSelected("j",i))
          {
            if(details) scene.object("Joint" + i + "__").setMaterial(markedW);
            else scene.object("Joint" + i + "__").setMaterial(markedW2);
          }
        }
      }
      if(obiekt.name.startsWith("Joint"))
      {
        int id = Integer.valueOf(obiekt.name.substring(5,obiekt.name.length()-2)).intValue();
        //znowu kombinacje zwiazane z odznaczaniem z Ctrl
        if(fram.elementStrongSelected("j",id) && controlPressed)
        {
          fram.unmarkJoint(id);
          if(details) scene.object("Joint" + id + "__").setMaterial(zielony2);
          else scene.object("Joint" + id + "__").setMaterial(color);
          return;
        }
        //koniec jaj...
        fram.markJoint(id);
        if(details) scene.object("Joint" + id + "__").setMaterial(markedS);
        else scene.object("Joint" + id + "__").setMaterial(markedS2);
      }
      //koniec zmiany kolorkow (Joint i Part skladaja sie z roznych obiektow)
      if(obiekt.name.startsWith("Neuron"))
      {
        int id = Integer.valueOf(obiekt.name.substring(6,obiekt.name.length()-2)).intValue();
        //odznaczanie neuronu z wcisnietym klawiszem Ctrl
        if(fram.elementStrongSelected("n",id) && controlPressed)
        {
          fram.unmarkNeuron(id);
          if(details) scene.object("Neuron" + id + "__").setMaterial(zielony2);
          else scene.object("Neuron" + id + "__").setMaterial(color);
          return;
        }
        //i po bolu...
        fram.markNeuron(id);
        if(details) scene.object("Neuron"+id+"__").setMaterial(markedS);
        else scene.object("Neuron"+id+"__").setMaterial(markedS2);
      }
      markedObject = obiekt.name;
      //tworzymy opis zaznaczanego obiektu
      if(markedObject.startsWith("Part"))
      {
        int id = Integer.valueOf(markedObject.substring(4,markedObject.length()-4)).intValue();
        //((Neuron)MyModel.vNeurons.elementAt(id)).properties.contains("p");
        description1 = "Part" + id + ": m=" + fram.getPartProp(id,"m") + "; fr=" + fram.getPartProp(id,"fr") + "; ing=" + fram.getPartProp(id,"ing") + "; as=" + fram.getPartProp(id,"as") + ";";
        description2 = "Neurons: ";
        for(int i=0; i<fram.getNeuroCount(); i++)
        {
          if(((Integer) fram.getNeuroProp(i,"p")).intValue() == id)
            description2 = description2 + "n" + i +", ";
        }
      }
      else if(markedObject.startsWith("Joint"))
      {
        int id = Integer.valueOf(markedObject.substring(5,markedObject.length()-2)).intValue();
        description1 = "Joint" + id + ": stam=" + fram.getJointProp(id,"stam") + ";";
        description2 = "Neurons: ";
        for(int i=0; i<fram.getNeuroCount(); i++)
        {
          if(((Integer) fram.getNeuroProp(i,"j")).intValue() == id)
            description2 = description2 + "n" + i +", ";
        }
      }
      else if(markedObject.startsWith("Neuron"))//jest neuronem
      {
        int id = Integer.valueOf(markedObject.substring(6,markedObject.length()-2)).intValue();
        String typik = (String)fram.getNeuroProp(id,"d");
        description1 = "Neuron " + id + " (" + typik + ")";
        description2="";
      }
      //ustawienie koloru jointow w zaleznosci od operacji edycyjnych
      for(int i=0; i<fram.getJointCount(); i++)
      {
        if(fram.elementStrongSelected("j",i))
        {
          if(details) scene.object("Joint" + i + "__").setMaterial(markedS);
          else scene.object("Joint" + i + "__").setMaterial(markedS2);
        }
        else if(fram.elementWeakSelected("j",i))
        {
          if(details) scene.object("Joint" + i + "__").setMaterial(markedW);
          else scene.object("Joint" + i + "__").setMaterial(markedW2);
        }
        else
        {
          if(details) scene.object("Joint" + i + "__").setMaterial(zielony2);
          else scene.object("Joint" + i + "__").setMaterial(color);
        }
      }
      //i kolorki ustawione...
      redrawNet=true;
      drawDescription();
      scene.rebuild();
      //trial - powinno byc dla odswiezania, ale psuje widok neuronow
      if(!markedObject.startsWith("Neuron")) fram.fireSignificantEditEvent();
    }
  }
  
  // moze costam dodac do sceny gdy jest zaznaczony element
  public void updateSceneForDescription(String type, int id, float posX, float posY, float posZ)
  { // ale w tu akurat nic sie nie dzieje
  }
  
  /**
   * Creates a text description of last marked object that is shown at the bottom of the screen.
   */
  public void drawDescription()//odzwierciedla zaznaczenie elementu
  {
    if(markedObject==null) return;//jak null to lipa
    float posX = 0;//pozycja (dla parta x,y,z, a dla jointa srodek:))
    float posY = 0;
    float posZ = 0;
    if(markedObject.startsWith("Part"))
    {
      int id = Integer.valueOf(markedObject.substring(4,markedObject.length()-4)).intValue();
      posX = ((Float)fram.getPartProp(id,"x")).floatValue();
      posY = ((Float)fram.getPartProp(id,"y")).floatValue();
      posZ = ((Float)fram.getPartProp(id,"z")).floatValue();
      updateSceneForDescription("p", id, posX-centralPoint[0], posY-centralPoint[1], posZ-centralPoint[2]);//przy rozmieszczaniu neuronow
      //uwzgledniam jeszcze przesuniecie zwiazane z centrowaniem sceny
      return;//przy parcie nie rysujemy strzalek
    }
    else if(markedObject.startsWith("Joint"))//gdy jest jointem
    {
      int id = Integer.valueOf(markedObject.substring(5,markedObject.length()-2)).intValue();
      posX = (((Float)fram.getPartProp(((Integer)fram.getJointProp((int)id,"p1")).intValue(),"x")).floatValue() + ((Float)fram.getPartProp(((Integer)fram.getJointProp((int)id,"p2")).intValue(),"x")).floatValue())/2;
      posY = (((Float)fram.getPartProp(((Integer)fram.getJointProp((int)id,"p1")).intValue(),"y")).floatValue() + ((Float)fram.getPartProp(((Integer)fram.getJointProp((int)id,"p2")).intValue(),"y")).floatValue())/2;
      posZ = (((Float)fram.getPartProp(((Integer)fram.getJointProp((int)id,"p1")).intValue(),"z")).floatValue() + ((Float)fram.getPartProp(((Integer)fram.getJointProp((int)id,"p2")).intValue(),"z")).floatValue())/2;
      updateSceneForDescription("j", id, posX-centralPoint[0], posY-centralPoint[1], posZ-centralPoint[2]);//j.w. z partem
      //jedyna roznica polega na sposobie liczenia wsp. (na srodku Jointa)
    }
    else if(markedObject.startsWith("Neuron"))//zaznaczamy neuron
    {
      //zaznaczono neuron: na podstawie neuronu okreslamy typ i nr obiektu,
      //ktorego neurony powinny zostac narysowane
      int idek = Integer.valueOf(markedObject.substring(6,markedObject.length()-2)).intValue();
      String glownyObiekt = "";
      if (fram.neuroPropExists(idek,"p"))
      {
        glownyObiekt = "Part"+fram.getNeuroProp(idek,"p")+"____";
      }
      else if (fram.neuroPropExists(idek,"j"))
      {
        glownyObiekt = "Joint"+fram.getNeuroProp(idek,"j")+"__";
      }
      if(glownyObiekt.startsWith("Part"))
      {
        int id = Integer.valueOf(glownyObiekt.substring(4,glownyObiekt.length()-4)).intValue();
        posX = ((Float)fram.getPartProp(id,"x")).floatValue();
        posY = ((Float)fram.getPartProp(id,"y")).floatValue();
        posZ = ((Float)fram.getPartProp(id,"z")).floatValue();
        updateSceneForDescription("p", id, posX-centralPoint[0], posY-centralPoint[1], posZ-centralPoint[2]);//przy rozmieszczaniu neuronow
        //uwzgledniam jeszcze przesuniecie zwiazane z centrowaniem sceny
      }
      else if(glownyObiekt.startsWith("Joint"))//gdy jest jointem
      {
        int id = Integer.valueOf(glownyObiekt.substring(5,glownyObiekt.length()-2)).intValue();
        posX = (((Float)fram.getPartProp(((Integer)fram.getJointProp((int)id,"p1")).intValue(),"x")).floatValue() + ((Float)fram.getPartProp(((Integer)fram.getJointProp((int)id,"p2")).intValue(),"x")).floatValue())/2;
        posY = (((Float)fram.getPartProp(((Integer)fram.getJointProp((int)id,"p1")).intValue(),"y")).floatValue() + ((Float)fram.getPartProp(((Integer)fram.getJointProp((int)id,"p2")).intValue(),"y")).floatValue())/2;
        posZ = (((Float)fram.getPartProp(((Integer)fram.getJointProp((int)id,"p1")).intValue(),"z")).floatValue() + ((Float)fram.getPartProp(((Integer)fram.getJointProp((int)id,"p2")).intValue(),"z")).floatValue())/2;
        updateSceneForDescription("j", id, posX-centralPoint[0], posY-centralPoint[1], posZ-centralPoint[2]);//j.w. z partem
        //jedyna roznica polega na sposobie liczenia wsp. (na srodku Jointa)
      }
      return;//przy neuronie nie rysujemy strzalek - koniec metody
    }
    else return;//kliknieto na boxie albo strzalkach
    //UWAGA - strzalki ustawiane sa tylko dla Jointow
    //ponadto mowa o Jointach, ktore posiadaja opcje dx
    int id = Integer.valueOf(markedObject.substring(5,markedObject.length()-2)).intValue();
    if(((Float)fram.getJointProp(id,"dx")).floatValue()!=0)
    {
      float dlugosc = ((Float)fram.getJointProp(id,"dx")).floatValue();
      idx3d_Object opis1 = idx3d_ObjectFactory.CYLINDER(dlugosc,0.02f,4);//OX
      scene.addObject("Description1",opis1);
      scene.object("Description1").setMaterial(new idx3d_Material(0xFF0000));
      opis1.rotate(0,0,idx3d_Math.pi/2);
      opis1.setPos(posX+dlugosc/2-centralPoint[0],posY-centralPoint[1],posZ-centralPoint[2]);
      idx3d_Object opis4 = idx3d_ObjectFactory.CONE(0.25f,0.1f,4);//OX
      scene.addObject("Description4",opis4);
      scene.object("Description4").setMaterial(new idx3d_Material(0xFF0000));
      opis4.rotate(0,0,idx3d_Math.pi/2);
      if(dlugosc<0) opis4.rotate(0,0,idx3d_Math.pi);
      opis4.setPos(posX+dlugosc+/*0.45f*/-centralPoint[0],posY-centralPoint[1],posZ-centralPoint[2]);
    }
    if(((Float)fram.getJointProp(id,"dy")).floatValue()!=0)
    {
      float dlugosc = ((Float)fram.getJointProp(id,"dy")).floatValue();
      idx3d_Object opis2 = idx3d_ObjectFactory.CYLINDER(dlugosc,0.02f,4);//OY
      scene.addObject("Description2",opis2);
      scene.object("Description2").setMaterial(new idx3d_Material(0x00FF00));
      opis2.setPos(posX-centralPoint[0],posY+dlugosc/2-centralPoint[1],posZ-centralPoint[2]);
      idx3d_Object opis5 = idx3d_ObjectFactory.CONE(0.25f,0.1f,4);//OX
      scene.addObject("Description5",opis5);
      scene.object("Description5").setMaterial(new idx3d_Material(0x00FF00));
      if(dlugosc<0) opis5.rotate(idx3d_Math.pi,0,0);
      opis5.setPos(posX-centralPoint[0],posY+dlugosc/*+0.45f*/-centralPoint[1],posZ-centralPoint[2]);
    }
    if(((Float)fram.getJointProp(id,"dz")).floatValue()!=0)
    {
      float dlugosc = ((Float)fram.getJointProp(id,"dz")).floatValue();
      idx3d_Object opis3 = idx3d_ObjectFactory.CYLINDER(dlugosc,0.02f,4);//OZ
      scene.addObject("Description3",opis3);
      scene.object("Description3").setMaterial(new idx3d_Material(0x0000FF));
      opis3.rotate(idx3d_Math.pi/2,0,0);
      opis3.setPos(posX-centralPoint[0],posY-centralPoint[1],posZ+dlugosc/2-centralPoint[2]);
      idx3d_Object opis6 = idx3d_ObjectFactory.CONE(0.25f,0.1f,4);//OX
      scene.addObject("Description6",opis6);
      scene.object("Description6").setMaterial(new idx3d_Material(0x0000FF));
      opis6.rotate(-idx3d_Math.pi/2,0,0);
      if(dlugosc<0) opis6.rotate(idx3d_Math.pi,0,0);
      opis6.setPos(posX-centralPoint[0],posY-centralPoint[1],posZ+dlugosc/*+0.45f*/-centralPoint[2]);
    }
/*		idx3d_Object opis1 = idx3d_ObjectFactory.CYLINDER(0.5f,0.02f,4);//OX
                scene.addObject("Description1",opis1);
                scene.object("Description1").setMaterial(new idx3d_Material(0xFF0000));
                opis1.rotate(0,0,idx3d_Math.pi/2);
                opis1.setPos(posX+0.25f-centralPoint[0],posY-centralPoint[1],posZ-centralPoint[2]);
                idx3d_Object opis2 = idx3d_ObjectFactory.CYLINDER(0.5f,0.02f,4);//OY
                scene.addObject("Description2",opis2);
                scene.object("Description2").setMaterial(new idx3d_Material(0x00FF00));
                opis2.setPos(posX-centralPoint[0],posY+0.25f-centralPoint[1],posZ-centralPoint[2]);
                idx3d_Object opis3 = idx3d_ObjectFactory.CYLINDER(0.5f,0.02f,4);//OZ
                scene.addObject("Description3",opis3);
                scene.object("Description3").setMaterial(new idx3d_Material(0x0000FF));
                opis3.rotate(idx3d_Math.pi/2,0,0);
                opis3.setPos(posX-centralPoint[0],posY-centralPoint[1],posZ+0.25f-centralPoint[2]);
                idx3d_Object opis4 = idx3d_ObjectFactory.CONE(0.25f,0.1f,4);//OX
                scene.addObject("Description4",opis4);
                scene.object("Description4").setMaterial(new idx3d_Material(0xFF0000));
                opis4.rotate(0,0,idx3d_Math.pi/2);
                opis4.setPos(posX+0.45f-centralPoint[0],posY-centralPoint[1],posZ-centralPoint[2]);
                idx3d_Object opis5 = idx3d_ObjectFactory.CONE(0.25f,0.1f,4);//OX
                scene.addObject("Description5",opis5);
                scene.object("Description5").setMaterial(new idx3d_Material(0x00FF00));
                opis5.setPos(posX-centralPoint[0],posY+0.45f-centralPoint[1],posZ-centralPoint[2]);
                idx3d_Object opis6 = idx3d_ObjectFactory.CONE(0.25f,0.1f,4);//OX
                scene.addObject("Description6",opis6);
                scene.object("Description6").setMaterial(new idx3d_Material(0x0000FF));
                opis6.rotate(-idx3d_Math.pi/2,0,0);
                opis6.setPos(posX-centralPoint[0],posY-centralPoint[1],posZ+0.45f-centralPoint[2]);
 */	}
  
  /**
   * Updates the background texture after changing the mark of an object.
   * It puts images of appropriate neurons in the backround.
   */
  public void updateBackground()//ustawia odpowiednie tlo (zaznaczenie lub bez)
  {
    if(!redrawNet)return;
    int id = -1;		//co zaznaczono
    int licznik = 0;	//ile na tym jest neuronow
    if(markedObject!=null)//ustalamy typ, liczbe neuronow i id obiektu (o ile zaznaczono)
    {
      description2 = "Neurons: ";
      if(markedObject.startsWith("Part"))
      {
        id = Integer.valueOf(markedObject.substring(4,markedObject.length()-4)).intValue();
        //((Neuron)MyModel.vNeurons.elementAt(id)).properties.contains("p");
        for(int i=0; i<fram.getNeuroCount(); i++) if (fram.neuroPropExists(i,"p")) if( ((Integer) fram.getNeuroProp(i,"p")).intValue() == id) licznik++;
        description1 = "Part" + id + ": m=" + fram.getPartProp(id,"m") + "; fr=" + fram.getPartProp(id,"fr") + "; ing=" + fram.getPartProp(id,"ing") + "; as=" + fram.getPartProp(id,"as") + ";";
      }
      else if(markedObject.startsWith("Joint"))
      {
        id = Integer.valueOf(markedObject.substring(5,markedObject.length()-2)).intValue();
        for(int i=0; i<fram.getNeuroCount(); i++) if (fram.neuroPropExists(i,"j")) if( ((Integer)fram.getNeuroProp(i,"j")).intValue() == id) licznik++;
        description1 = "Joint" + id + ": stam=" + fram.getJointProp(id,"stam") + ";";
      }
      else if(markedObject.startsWith("Neuron"))
      {
        id = Integer.valueOf(markedObject.substring(6,markedObject.length()-2)).intValue();
        String typik = (String)fram.getNeuroProp(id,"d");
        description1 = "Neuron" + id + "(" + typik + ")";
        description2 = "";
        idx3d_Texture swieze = null;
        swieze = new idx3d_Texture(400,400);//zwykle niebo, bo na neuronie nie ma neuronow
        System.arraycopy(tlo4.pixel,0,swieze.pixel,0,400*400);
        scene.environment.setBackground(swieze);
        return;
      }
    }
    if(markedObject!=null && licznik!=0)//jak zaznaczono i sa neurony
    {							        //jest sens teksturowania
      int a = ((int)(Math.sqrt(licznik)-0.0001))+1;//tekstury nakladamy w kwadracie
      int rozmiar = 400;				//domyslny rozmiar tekstury
      if(licznik>16) rozmiar = a*100; //duzo neuronow to zwiekszamy, zeby dodatkowo nie skalowac
      idx3d_Texture swieze = null;
      if(licznik<=16)
      {
        swieze = new idx3d_Texture(400,400);//poczatkowo zwykle niebo
        System.arraycopy(tlo4.pixel,0,swieze.pixel,0,400*400);
      }
      else if(licznik>16 && licznik<=25)
      {
        swieze = new idx3d_Texture(500,500);
        System.arraycopy(tlo5.pixel,0,swieze.pixel,0,500*500);
      }
      else if(licznik>25 && licznik<=36)
      {
        swieze = new idx3d_Texture(600,600);
        System.arraycopy(tlo6.pixel,0,swieze.pixel,0,600*600);
      }
      else
      {
        swieze = idx3d_TextureFactory.SKY(a*100,a*100,3);
      }
      int numer = 0;					//liczy kolejne neurony
      int lookFor = 0;				//do znajdowania kolejnego neuronu incydentnego w tablicy
      for(int ii=0; ii<a; ii++)		//jedziemy po kwadracie
      {
        for(int jj=0; jj<a; jj++)   //j.w.
        {
          if(markedObject.startsWith("Part"))//inaczej szukamy kolejnego
          {								   //neuronu w tablicy dla
            while(!fram.neuroPropExists(lookFor,"p") || ((Integer)fram.getNeuroProp(lookFor,"p")).intValue() != id)
            {
              lookFor++;
            }
          }
          else if(markedObject.startsWith("Joint"))
          {
            while(!fram.neuroPropExists(lookFor,"j") || ((Integer) fram.getNeuroProp(lookFor,"j")).intValue() != id)
            {
              lookFor++;
            }
          }//jak mamy kolejny neuron to w odpowiednim obszarze tla wygaszamy neurony okreslone odpowiednim elementem mapy
          description2 = description2 + "n" + lookFor +", ";
          int numerek=0;
          String zmienna = "" + fram.getNeuroProp(lookFor,"d");
          
          int[] mapa = (int[]) map.get(zmienna);
          
          for(int i=0; i<100; i++) for(int j=0; j<100; j++)
          {
            if(mapa[i*100+j]==0) swieze.pixel[ii*100*rozmiar+jj*100+i*rozmiar+j]=0;
          }//po nalozeniu mapu na teksture tla
          numer++;//zaznaczamy, ze dodano kolejny neuron
          lookFor++;//przeskakujemy na kolejne miejsce w tablicy
          if(numer==licznik) break;//i jak wszystkie narysowane to koniec
        }
        if(numer==licznik) break;
      }
      scene.environment.setBackground(swieze);//w koncu ustawiamy tlo:) ufff
    }
    else//jesli nic nie zaznaczono, to tlo pozostaje bez zmian w porownaniu ze stanem poczatkowym
    {
      scene.environment.setBackground(tlo4);//bylo swieze
    }
    redrawNet = false;
  }
  
  /**
   * Enables to show exact properties of element that was clicked on in special window.
   */
  public void showProperties(idx3d_Object obiekt)//method
  {
    if(obiekt==null)
    {
      //description1 = "";
      //description2 = "";
      return;
    }
    int id = -1;
    String typ = "unknown";
    if(obiekt.name.startsWith("Part"))
    {
      id = Integer.valueOf(obiekt.name.substring(4,obiekt.name.length()-4)).intValue();
      typ = "p";
    }
    else if(obiekt.name.startsWith("Joint"))
    {
      id = Integer.valueOf(obiekt.name.substring(5,obiekt.name.length()-2)).intValue();
      typ = "j";
    }
    else if(obiekt.name.startsWith("Neuron"))
    {
      id = Integer.valueOf(obiekt.name.substring(6,obiekt.name.length()-2)).intValue();
      typ = "n";
    }
    else
    {
      //description1 = "";
      //description2 = "";
      return;
    }
    //description1 = "This should show properties of the element you clicked on.";
    //description2 = "Type: " + typ + "; Number: " + id;
  }
  /**
   * Enables to show exact properties of element that was clicked on in special window.
   */
  public String[] showProperties(int x, int y)//method
  {
    idx3d_Object obiekt = this.scene.identifyObjectAt(x,y);//id obiektu pod kursorem
    if(obiekt==null)
    {
      //description1 = "";
      //description2 = "";
      return null;
    }
    int id = -1;
    String typ = "unknown";
    if(obiekt.name.startsWith("Part"))
    {
      id = Integer.valueOf(obiekt.name.substring(4,obiekt.name.length()-4)).intValue();
      typ = "p";
    }
    else if(obiekt.name.startsWith("Joint"))
    {
      id = Integer.valueOf(obiekt.name.substring(5,obiekt.name.length()-2)).intValue();
      typ = "j";
    }
    else if(obiekt.name.startsWith("Neuron"))
    {
      id = Integer.valueOf(obiekt.name.substring(6,obiekt.name.length()-2)).intValue();
      typ = "n";
    }
    else
    {
      //description1 = "";
      //description2 = "";
      return null;
    }
    //description1 = "Properties of the element you clicked on.";
    //description2 = "Type: " + typ + "; Number: " + id;
    String[] s =
    {String.valueOf(id), typ};
    return s;
  }
  //-----------------------------------------------------------------------------
  //---------------------a na koniec dostepne akcje------------------------------
  //-----------------------------------------------------------------------------
  /**
   * Basic mouse operations, like clicking and dragging.
   */
  public void mousePressed(MouseEvent evt)
  {
    //zeby mozna bylo korzystac z drugiego przyciku myszy jest ten if potrzebny
    if(evt.getModifiers()==MouseEvent.BUTTON3_MASK)
    {
      idx3d_Object obj = this.scene.identifyObjectAt(evt.getPoint().x,evt.getPoint().y);//id obiektu pod kursorem
      showProperties(obj);
      oldx=evt.getPoint().x;//zeby mozna bylo bez zaklocen dragowac prawym
      oldy=evt.getPoint().y;
      return;
    }
    scene.setAntialias(false);//zeby bylo brzydko i szybko :)
    oldx=evt.getPoint().x;
    oldy=evt.getPoint().y;
    if(addingJoint) addJointProcedure(oldx,oldy);//jak dodajemy Jointa to Jointa
    else if (addingPart) AddPart(oldx,oldy);//jak Parta to Parta
    else if (translating) return;//chodzi o to, by podczas przesuwania nie zaznaczac obiektow
    else
    {
      if(evt.isShiftDown()) shiftPressed = true;//zaznaczamy 1 lub wiele, w zaleznosci od tego czy ctrl wcisniety
      else shiftPressed = false;
      if(evt.isControlDown()) controlPressed = true;
      else controlPressed = false;
      idx3d_Object obj = this.scene.identifyObjectAt(oldx,oldy);//id obiektu pod kursorem
      markObject(obj);//zaznaczenie obiektu pod kursorem
    }
  }
  
  /**
   * Handle for basic mouse operation.
   */
  public void mouseReleased(MouseEvent evt)
  {
    if(translating)
    {
      translating = false;//po zwolnieniu przycisku myszy juz nie przesuwamy
      //trial
      fram.recountCoordinates();
      fram.checkValidity();
      fram.fireSignificantEditEvent();
      //trial ends
      redrawScene();
    }
    //translate(oldx, oldy, evt.getPoint().x, evt.getPoint().y);
    //powyzsza instrukcja oznaczalaby przesuniecie w jednym kroku, bez podgladu
    if (!autorotation) scene.setAntialias(true);//jesli sie obraca to ma byc szybko
    repaint();
  }
  
  /**
   * Handle for basic mouse operation.
   */
  public void mouseDragged(MouseEvent evt)
  {
    if(translating)
    {
      translate(oldx, oldy, evt.getPoint().x, evt.getPoint().y);
      //przesuwamy o jeden kroczek :)
      oldx=evt.getPoint().x;//i zapamietujemy, do ktorego miejsca przesunelismy
      oldy=evt.getPoint().y;//zeby framstick sie nadmiarowo nie rozjechal
      //jesli chcemy przesunac pare elementow, to scena nie powinna sie obracac
      //po przesunieciu natychmiast powaracamy do domyslnego trybu
    }
    else
    {
      float dx=(float)(evt.getPoint().y-oldy)/50;
      float dy=(float)(oldx-evt.getPoint().x)/50;
      scene.rotate(dx,dy,0);//that was OK
      oldx=evt.getPoint().x;
      oldy=evt.getPoint().y;
      repaint();
    }
  }
  
  /**
   * Handle for basic mouse operation.
   */
  public void mouseClicked(MouseEvent evt)
  {}
  /**
   * Handle for basic mouse operation.
   */
  public void mouseEntered(MouseEvent evt)
  {}
  /**
   * Handle for basic mouse operation.
   */
  public void mouseExited(MouseEvent evt)
  {}
  /**
   * Handle for basic mouse operation.
   */
  public void mouseMoved(MouseEvent evt)
  {}
  /**
   * Handle for basic mouse operation.
   */
  /*
  public void mouseWheelMoved(MouseWheelEvent evt)
  {
    if(evt.getWheelRotation()==-1) zoomOut();
    else zoomIn();
  }
  */
/*	public boolean action(Event e, Object test)
        {
                if (test.equals("Zoom in ")) zoomIn();
                else if (test.equals("Zoom out")) zoomOut();
                else if (test.equals("   Box  ")) boxVisible();
                else if (test.equals("Default ")) { defaultCameraPos(); repaint(); }
                else if (test.equals("Rotation")) setAutorotation();
                else if (test.equals("Details ")) setDetails();
                else if (test.equals(" Wires  ")) setWires();
                else if (test.equals(" Delete ")) { DeleteElem(); repaint(); }
                else if (test.equals(" Undo "))	  { Undo(); repaint(); }
                else if (test.equals(" Redo "))   { Redo(); repaint(); }
                else if (test.equals(" AddJ "))   { addingPart= false; AddJoint(); repaint(); }
                else if (test.equals("AddPFront")) { addingPart=true; //tryb dodawania parta
                                                                                         addingJoint=false; //wiec nie mozna dodac jointa
                                                                                         autorotation=false;//wylaczamy rotacje by nie bylo przeksztalcen
                                                                                         partAddingFlag=0;//oznaczamy plaszczyzne flaga
                                                                                         prepareScene();//scene trzeba odtworzyc dla zachowania wspolrzednych
                                                                                         createLights();//razem ze swiatlami
                                                                                         scene.defaultCamera.setPos(0,0,-view);//i kamera
                                                                                         redrawScene();//jeszcze przebudowanie nowki
                                                                                         description1=I18N.getMessage("WhereAddP","Where would You like to add the Part?");
                                                                                         description2="";//i zapytanie o pozycje nowego parta
                                                                                         repaint();//przerysowanie panelu
                                                                                        }
                else if (test.equals("AddPSide")) { addingPart=true; //wszystko jak powyzej
                                                                                         addingJoint=false;
                                                                                         autorotation=false;
                                                                                         partAddingFlag=1;//tylko odpowiednio flaga inna
                                                                                         prepareScene();
                                                                                         createLights();
                                                                                         scene.defaultCamera.setPos(0,0,-view);
                                                                                         scene.rotate(0,idx3d_Math.pi/2,0);	//i obrot sceny dla zmiany widoku
                                                                                         redrawScene();
                                                                                         description1=I18N.getMessage("WhereAddP","Where would You like to add the Part?");
                                                                                         description2="";
                                                                                         repaint();
                                                                                        }
                else if (test.equals("AddPPlan")) { addingPart=true; //wszystko j.w.
                                                                                         addingJoint=false;
                                                                                         autorotation=false;
                                                                                         partAddingFlag=2;
                                                                                         prepareScene();
                                                                                         createLights();
                                                                                         scene.defaultCamera.setPos(0,0,-view);
                                                                                         scene.rotate(idx3d_Math.pi/2,0,0);
                                                                                         redrawScene();
                                                                                         description1=I18N.getMessage("WhereAddP","Where would You like to add the Part?");;
                                                                                         description2="";
                                                                                         repaint();
                                                                                        }
                else return false;
                return true;
        }
 */
  //----- bajery edycyjne
  
  /**
   * Method used for deleting marked elements.
   */
  public void DeleteElem()
  {
    if (markedObject==null) return;
    int id=-1;
    if(markedObject.startsWith("Part"))
    {
      if(fram.getPartCount()==1)
      {
        description1=I18N.getMessage("DelLastP");
        description2="";
        return;
      }
    }
    for(int i=fram.getPartCount()-1; i>=0; i--)
    {
      if(fram.elementStrongSelected("p",i) && fram.getPartCount()>1)//min 1 part
      {
        fram.removePart(i);
        fram.recountCoordinates();
      }
    }
    for(int i=fram.getJointCount()-1; i>=0; i--)
    {
      if(fram.elementStrongSelected("j",i))
      {
        fram.removeJoint(i);
        fram.recountCoordinates();
      }
    }
    //jezeli kasowany jest neuron, to mozna reszte neuronow pokazywac
    boolean dziwnaZmiana = false;//jesli jest to mozliwe
    String nazwa = "";//nazwa obiektu, ktory zaznaczymy, na ktorym lezy usuwany neuron
    if(markedObject.startsWith("Neuron"))//jesli ostatnio zaznaczono neuron
    {
      //zaznaczono neuron: na podstawie neuronu okreslamy typ i nr obiektu,
      //ktorego neurony powinny zostac narysowane
      int idek = Integer.valueOf(markedObject.substring(6,markedObject.length()-2)).intValue();
      int numer = -1;
      if (fram.neuroPropExists(idek,"p"))//jak nie usunieto do tej pory parta
      {
        numer = ((Integer)fram.getNeuroProp(idek,"p")).intValue();//to numer
        if(fram.markPart(numer))//zaznaczamy go
        {
          dziwnaZmiana = true;//potwierdzamy mozliwosc podstawienia
          nazwa = "Part" + numer + "____";//i dajemy nazwe dla markedObject
        }
      }
      else if (fram.neuroPropExists(idek,"j")) //j.w.
      {
        numer = ((Integer) fram.getNeuroProp(idek,"j")).intValue();
        if(fram.markJoint(numer))
        {
          dziwnaZmiana = true;
          nazwa = "Joint" + numer + "__";
        }
      }
    }
    if(dziwnaZmiana) markedObject = nazwa;//daje rade (p lub J istnial)
    else markedObject = null;//nie dalo rady (neuron juz wisial w powietrzu)
    for(int i=fram.getNeuroCount()-1; i>=0; i--)
    {
      if(fram.elementStrongSelected("n",i))
      {
        fram.removeNeuron(i);
      }
    }
    //markedObject=null;//bylo ty zanim pojawilo sie zachowywanie neuronow
    description1 = "";
    description2 = "";
    redrawScene();
    fram.checkValidity();
    fram.fireSignificantEditEvent();
  }
  
  /**
   * Method used to cancel recently performed operations.
   */
  public void Undo()
  {
    if (fram.undo())
    {
      //odznaczamy wszystko just in case
      for(int i=0; i<fram.getPartCount(); i++) fram.unmarkPart(i);
      for(int i=0; i<fram.getJointCount(); i++) fram.unmarkJoint(i);
      for(int i=0; i<fram.getNeuroCount(); i++) fram.unmarkNeuron(i);
      markedObject=null;
      description1 = "";
      description2 = "";
      redrawScene();
      fram.checkValidity();
      fram.fireSignificantEditEvent();
    }
  }
  
  /**
   * Method used to redo recently cancelled operations.
   */
  public void Redo()
  {
    if (fram.redo())
    {
      for(int i=0; i<fram.getPartCount(); i++) fram.unmarkPart(i);
      for(int i=0; i<fram.getJointCount(); i++) fram.unmarkJoint(i);
      for(int i=0; i<fram.getNeuroCount(); i++) fram.unmarkNeuron(i);
      markedObject=null;
      description1 = "";
      description2 = "";
      redrawScene();
      fram.checkValidity();
      fram.fireSignificantEditEvent();
    }
  }
  
  /**
   * Method used to finalize adding Joint procedure.
   */
  public void AddJoint()
  {
    if (markedObject==null)//pierwszy z elementow musi byc zaznaczony
    {
      description1=I18N.getMessage("PartNotMarked");
      description2="";
      return;
    }
    if(markedObject.startsWith("Part"))
    {
      addingJoint = true;
      addingPart = false;//jak chcemy dodac jointa, to glupio by bylo jak bysmy jednoczesnie dodali sobie parta
      translating = false;
      description1=I18N.getMessage("Mark2Part");
      description2="";
    }
    else
    {
      description1=I18N.getMessage("PartNotMarked");
      description2="";
      return;
    }
  }
  
  /**
   * Method sets the machine state into adding Joint mode and begin performing adding joint procedure.
   */
  public void addJointProcedure(int x, int y)
  {
    if (markedObject==null || !markedObject.startsWith("Part"))//po wybraniu funkcji mogli odznaczyc pierwszy part
    {
      description1=I18N.getMessage("PartNotMarked");
      description2="";
      addingJoint=false;
      return;
    }
    idx3d_Object obj = this.scene.identifyObjectAt(x,y);//identyfikujemy drugi
    if (obj!=null && obj.name.startsWith("Part"))//musi byc partem :)
    {
      String name = obj.name;
      int id1 = Integer.valueOf(markedObject.substring(4,markedObject.length()-4)).intValue();
      int id2 = Integer.valueOf(name.substring(4,name.length()-4)).intValue();
      fram.addJoint(id1,id2);
      fram.markJoint(fram.getJointCount());//przylega do Parta zaznaczonego, wiec trzeba zaznaczyc
      redrawScene();
      description1=I18N.getMessage("Jadded");
      description2="";
      addingJoint=false;
      fram.checkValidity();
      fram.fireSignificantEditEvent();//trial
    }
    else
    {
      description1=I18N.getMessage("YouHaveToMark2Part");
      description2=I18N.getMessage("UseAddJ");
      addingJoint=false;
      return;
    }
  }
  
  /**
   * Method used to finalize adding Part procedure.
   */
  public void AddPart(int x,int y)
  {
    addingPart = false;//koniecznie, zebysmy na okraglo nie dodawali partow kazdym kliknieciem
    d=getSize();//pobranie rozmiarow okna
    if(partAddingFlag==0) //dodajemy Parta z frontu (XY)
    {//wyliczenie wspolrzednych sceny na podstawie wspolrzednych na panelu
      //twierdzenie Talesa, rzutnia dwuwymiarowa, odpowiednie przesuniecie ukladu
      //oraz modyfikacja wspolrzednych o centrum modelu, ktore przesuniete jest
      //do punktu (0,0,0); scena jest odtwarzana, gdyz okreslenie wspolrzednych po
      //jej obrocie jest niemozliwe - dodawalibysmy party w absurdalne miejsca
      //ponadto dodawanie elementow w ten sposob ograniczone jest tylko do
      //podstawowych plaszczyzn ukladu 3d; a wszystko to w dwoch liniach kodu
      //(i dwoch kartkach a4 na papierze :))
      float zmiennaX = centralPoint[0] + (((x-d.width/2)*(view+1))/d.width);
      float zmiennaY = centralPoint[1] - (((y-(d.height-22)/2)*(view+1))/(d.height-22));
      fram.addPart(zmiennaX,zmiennaY,0);
    }
    else if(partAddingFlag==1)	//dodajemy Parta z boku(ZY)
    {
      float zmiennaZ = centralPoint[2] + (((x-d.width/2)*(view+1))/d.width);
      float zmiennaY = centralPoint[1] - (((y-(d.height-22)/2)*(view+1))/(d.height-22));
      fram.addPart(0,zmiennaY,zmiennaZ);
    }
    else	//partAddingFlag==2; dodajemy Parta z gory (XZ)
    {
      float zmiennaX = centralPoint[0] + (((x-d.width/2)*(view+1))/d.width);
      float zmiennaZ = centralPoint[2] - (((y-(d.height-22)/2)*(view+1))/(d.height-22));
      fram.addPart(zmiennaX,0,zmiennaZ);
    }
    description1=I18N.getMessage("Padded");//zeby bylo wiadomo, co sie dzieje
    description2="";
    redrawScene();//koniecznie
    fram.checkValidity();
    fram.fireSignificantEditEvent();//trial
  }
  
  /**
   * Method used to chnge positioning of marked Parts.
   */
  public void translate(int prevX, int prevY, int X, int Y)//przesuwa zaznaczone party o odpowiednie wartosci
  {
    if(!translating) return;
    //translating = false;//byloby, ale przy jednokrokowym przesuwaniu
    d=getSize();//pobranie rozmiarow okna
    if(translatingFlag==0) //(XY)
    {
      float transX = -((prevX-X)*(view+2))/d.width;
      float transY = ((prevY-Y)*(view))/(d.height-22);
      for(int i=0; i<fram.getPartCount(); i++)
      {
        if(fram.elementStrongSelected("p",i))
        {
          fram.translatePartCoords(i, transX, transY,0);
          if(details) scene.object("Part"+i+"____").setMaterial(zielony1);//kolorek "roboczego"
          else scene.object("Part"+i+"____").setMaterial(color1);
          scene.object("Part"+i+"____").shift(transX,transY,0);//podgladowego obiektu
        }
      }
      repaint();
    }
    else if(translatingFlag==1)	//(ZY)
    {
      float transZ = -((prevX-X)*(view+2))/d.width;
      float transY = ((prevY-Y)*(view))/(d.height-22);
      for(int i=0; i<fram.getPartCount(); i++)
      {
        if(fram.elementStrongSelected("p",i))
        {
          fram.translatePartCoords(i, 0, transY,transZ);
          if(details) scene.object("Part"+i+"____").setMaterial(zielony1);//robocza
          else scene.object("Part"+i+"____").setMaterial(color1);
          scene.object("Part"+i+"____").shift(0,transY,transZ);//kulka
        }
      }
      repaint();
    }
    else	//(XZ)
    {
      float transX = -((prevX-X)*(view+2))/d.width;
      float transZ = ((prevY-Y)*(view))/(d.height-22);
      for(int i=0; i<fram.getPartCount(); i++)
      {
        if(fram.elementStrongSelected("p",i))
        {
          fram.translatePartCoords(i, transX, 0,transZ);
          if(details) scene.object("Part"+i+"____").setMaterial(zielony1);//jw
          else scene.object("Part"+i+"____").setMaterial(color1);
          scene.object("Part"+i+"____").shift(transX,0,transZ);//:)
        }
      }
      repaint();
    }
    description1=I18N.getMessage("Translating");//zeby bylo wiadomo, co sie dzieje
    description2="";
    //redrawScene();//koniecznie//nie przebudowuje sceny, tylko manipuluje jednym obiektem
    repaint();//ale odswiezanie i tak jest potrzebne
  }
  
  protected class MyFramstickListener implements FramstickListener
  {
    public void significantEdit(FramstickEvent framEvent)
    {
      redrawScene();
      repaint();
      //System.out.println("Tazo: edit event !");
    }
    
    public void markChanged(FramstickEvent framEvent)
    {
      markedObject = null;
      description1="";
      description2="";
      buildCenter();
      defaultCameraPos();//naprawa zoom'a
      redrawScene();
      repaint();
      //System.out.println("Tazo: mark event !");
    }
  }
  protected void finalize() throws Throwable
  {
    System.out.println("Finalizing Tazo");
    this.removeAll();
    this.removeMouseListener(this);
    this.removeMouseMotionListener(this);
//    this.removeMouseWheelListener(this);
    fram.removeFramstickListener(mFL);
    mFL = null;
    
    scene.removeAllObjects();
    scene = null;
    centralPoint = null;
    aquariumSize = null;
    maxPoint = null;
    minPoint = null;
    markedS = null;
    markedW = null;
    markedS2 = null;
    markedW2 = null;
    color = null;
    color1 = null;
    black = null;
    zielony1 = null;		//trzy zielone
    zielony2 = null;		//kolorki
    zielony3 = null;		//najciemniejszy
    zolty = null;		//do wchlaniania
    friction = null;
    assimilation = null;
    rotationDirection = null;	//i w jakim kierunku
    d = null;						//wymiary okna
    markedObject = null;			//obiekt zaznaczony
    description1 = null;			//do opisu w dole ekranu
    description2 = null;
    
    tlo4 = null;//domyslne tlo
    tlo5 = null;
    tlo6 = null;
    super.finalize();
  }
}