/*
 * Created on 2003-07-05
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package fred;

import jGDK.I18N;

import java.awt.AWTEvent;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;
import java.text.NumberFormat;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JToggleButton;

/**
 * <p>MemoryUSage class</P>
 * <p>Dialog showing the runtime informations about the memory usage in the window and console.</P>
 * @author Damian Jarzbski
 */
public class MemoryUsage extends JDialog implements Runnable, ActionListener {

	private static JButton jButton = new JButton();
	private JToggleButton jToggle = new JToggleButton(I18N.getMessage("auto"));
	private JTextField text0 = new JTextField();
	private JTextField text1 = new JTextField();
	private JTextField text2 = new JTextField();
	private JTextField text3 = new JTextField();
	private static Runtime r = Runtime.getRuntime();
	int old;
	static String text="";
	static NumberFormat nf = NumberFormat.getInstance();

	MemoryUsage(int refreshTime, boolean auto) {
		nf.setGroupingUsed(true);
		text0.setText(String.valueOf(refreshTime));
		old = refreshTime;
		this.setTitle(I18N.getMessage("MemUsage"));
		jButton.setText(I18N.getMessage("Refresh"));
		jButton.addActionListener(this);
		this.getContentPane().setLayout(new GridLayout(5, 2));
		this.getContentPane().add(jToggle);
		this.getContentPane().add(jButton);
		this.getContentPane().add(new JLabel(I18N.getMessage("SleepMS")));
		this.getContentPane().add(text0);
		this.getContentPane().add(new JLabel(I18N.getMessage("FreeMem")));
		this.getContentPane().add(text1);
		this.getContentPane().add(new JLabel(I18N.getMessage("TotalMem")));
		this.getContentPane().add(text2);
		this.getContentPane().add(new JLabel(I18N.getMessage("MaxMem")));
		this.getContentPane().add(text3);
		text1.setEditable(false);
		text2.setEditable(false);
		text3.setEditable(false);
		this.pack();
		this.start();
		this.enableEvents(AWTEvent.WINDOW_EVENT_MASK);
		this.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
		jToggle.setSelected(auto);
		this.show();
	}
	private Thread clockThread = null;
	public void start() {
		if (clockThread == null) {
			clockThread = new Thread(this, "Clock");
			clockThread.start();
		}
	}
	int i = 1000;
	boolean running = true; 
	public void run() {
		while (running) {
			if (jToggle.isSelected()){
				this.show();
				this.actionPerformed(null);
			}
			try {
				try {
					i = Integer.parseInt(text0.getText());
				}
				catch (NumberFormatException e1) {
					i = old;
					text0.setText(String.valueOf(i));
				}
				Thread.sleep(i);
			}
			catch (InterruptedException e) {
				System.out.println("MemoryUsage->Cannot sleep more!");
				e.printStackTrace();
			}
		}
	}
	/**
	 * Distroing the window and the internal thread
	 */
	public void destroy() {
		running = false;
	}
	private static void showMemUsage() {
		System.out.println("**********"+text+"************");
		System.out.println(I18N.getMessage("FreeMem")+nf.format(r.freeMemory()));
		System.out.println(I18N.getMessage("TotalMem")+ nf.format(r.totalMemory()));
		System.out.println("**********************");
		text="";
	}
	/**
	 * Refreshing the informations
	 */
	public static void refresh() {
		showMemUsage();
	}
	/**
	 * Refreshing the informations and marks it in console with t String.
	 * @param t
	 */
	public static void refresh(String t) {
		text = t;
		showMemUsage();
	}
	/**
	 * Refreshing the informations.
	 */
	public void actionPerformed(ActionEvent e) {
		text1.setText(String.valueOf(nf.format(r.freeMemory())));
		text2.setText(String.valueOf(nf.format(r.totalMemory())));
		text3.setText(String.valueOf(nf.format(r.maxMemory())));
		showMemUsage();
	}
	protected void processWindowEvent(WindowEvent e) {
		if (e.getID() == WindowEvent.WINDOW_CLOSING) {
			destroy();
			clockThread = null;
		}
		super.processWindowEvent(e);
	}
	protected void finalize() throws Throwable {
		this.getContentPane().removeAll();
		clockThread = null;
		jButton = null;
		jToggle = null;
		text0 = null;
		text1 = null;
		text2 = null;
		text3 = null;
		r = null;
		super.finalize();
	}
}
