package fred;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;

import javax.swing.JFrame;
import javax.swing.JInternalFrame;
import javax.swing.JScrollPane;
import javax.swing.JTextPane;
import javax.swing.text.BadLocationException;
import javax.swing.text.SimpleAttributeSet;
import javax.swing.text.StyleConstants;
import javax.swing.text.StyledEditorKit;

import jGDK.ErrManager;


/**
 * <p>Messages class</p>
 * <p>Small class displaying the messages given from all other classes.</p>
 * @author Damian Jarzebski
 * @version 2.0
 */

public class Messages extends JInternalFrame {
  SimpleAttributeSet[] attrs = new SimpleAttributeSet[4];
  JScrollPane jScrollPane1 = new JScrollPane();
  JTextPane jTextPane1 = new JTextPane();

  /**
   * Construct the frame
   */
  public Messages() {
    super("Messages",
      true, //resizable
      true, //closable
      true, //maximizable
      false);//iconifiable

setSize(300,100);
setLocation(100,100);
    try {
      jbInit();
    }
    catch(Exception e) {
    	System.out.println("Error loading messages window:");
      e.printStackTrace();
    }
  }
  private void jbInit() throws Exception {
    this.setTitle("Messages");
    this.setMinimumSize(new Dimension(50, 50));
    this.setPreferredSize(new Dimension(456, 60));
    jScrollPane1.setMinimumSize(new Dimension(50, 21));
    jScrollPane1.setPreferredSize(new Dimension(400, 35));
    jScrollPane1.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
    jTextPane1.setBackground(new Color(100, 100, 250));
    jTextPane1.setPreferredSize(new Dimension(7, 30));
    jTextPane1.setToolTipText("");
    jTextPane1.setVerifyInputWhenFocusTarget(false);
    jTextPane1.setEditable(false);
    jTextPane1.setText("Dam");
    jTextPane1.setEditorKit(new StyledEditorKit());
    this.getContentPane().add(jScrollPane1, BorderLayout.CENTER);
    jScrollPane1.getViewport().add(jTextPane1, null);

	attrs = new SimpleAttributeSet[4];
	attrs[ErrManager.ER_MESSAGE] = new SimpleAttributeSet();
	StyleConstants.setFontFamily(attrs[ErrManager.ER_MESSAGE], "Arial");
	StyleConstants.setFontSize(attrs[ErrManager.ER_MESSAGE], 12);
	StyleConstants.setBold(attrs[ErrManager.ER_MESSAGE], true);

	attrs[ErrManager.ER_WARNING] =
		new SimpleAttributeSet(attrs[ErrManager.ER_MESSAGE]);
	StyleConstants.setItalic(attrs[ErrManager.ER_WARNING], true);
	StyleConstants.setForeground(
		attrs[ErrManager.ER_WARNING],
		Color.orange);

	attrs[ErrManager.ER_HINT] =
		new SimpleAttributeSet(attrs[ErrManager.ER_MESSAGE]);
	StyleConstants.setForeground(attrs[ErrManager.ER_HINT], Color.yellow);

	attrs[ErrManager.ER_ERROR] =
		new SimpleAttributeSet(attrs[ErrManager.ER_MESSAGE]);
	StyleConstants.setForeground(attrs[ErrManager.ER_ERROR], new Color(164,0,82));
	this.setDefaultCloseOperation(JInternalFrame.HIDE_ON_CLOSE);
  }
  /**
   * clears messages.
   */
  public void clear(){
//	try {
		jTextPane1.setText("");//.getStyledDocument()..remove(0,jTextPane1.getStyledDocument().getLength());
//	}
//	catch (BadLocationException e) {
//		System.out.println("Messages-->Error during clear the text.");
//	}
  }
/**
 * Appends new message (<CODE>text</CODE>) from <CODE>source</CODE> with the <CODE>attr</CODE>
 * @param source - source of this message
 * @param text - message
 * @param attr - the level of message
 */
  public void append(String source,String text,int attr) {
    if(!((attr>=0)&&(attr<=3))) attr=0;

        try {
          jTextPane1.getStyledDocument().insertString(jTextPane1.getStyledDocument().getLength(),
                                                      source + (source!=""?": ":"") + text +
                                                      "\n", attrs[attr]);
//          jTextPane1.insertIcon();
        } catch (BadLocationException ble) {
            System.err.println("Couldn't insert text.");
        }
//    jTextPane1.setText(jTextPane1.getText() + name.getName()+": "+text+"\n");
  }
 /////////////////////////////    main    //////////////////////////
 //////////////////////////////////////////////////////
 /**
  * method to test the setting of this window
  */
  public static void main(String[] args) {
    Messages mess = new Messages();
	mess.setSize(300,200);
  	  JFrame f = new JFrame("Fred - Main Frame");
            f.setName("Fred");
	  f.setSize(500,450);
	  f.getContentPane().setLayout(null);
		f.setLocation(50,50);
		f.setVisible(true);
	  f.getContentPane().add(mess);
    mess.setVisible(true);
	mess.append("Fred","styl zerowy - nieokreslony",ErrManager.ER_MESSAGE);
	mess.append("Fred","styl pierwszy - komunikat",ErrManager.ER_HINT);
	mess.append("Fred","styl drugi - warning",ErrManager.ER_WARNING);
	mess.append("Fred","styl trzeci - error",ErrManager.ER_ERROR);
  }
 //////////////////////////////////////////////////////
 //////////////////////////////////////////////////////
 protected void finalize() throws Throwable {
 	System.out.println("Finalizing messages window");
	 this.getContentPane().removeAll();
	attrs = null;
	jScrollPane1 = null;
	jTextPane1 = null;
	 super.finalize();
 }
  }