/*
 * Created on 2003-06-02
 *
 */
package fred;

import java.awt.Component;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.beans.PropertyVetoException;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.Hashtable;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JInternalFrame;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTable;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.event.TableModelEvent;
import javax.swing.table.AbstractTableModel;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.TableColumn;

import jGDK.ErrManager;
import jGDK.Framstick;
import jGDK.FramstickEvent;
import jGDK.FramstickListener;
import jGDK.GenotypeParser;
import jGDK.I18N;
import jGDK.Library;
import jGDK.Message;
import jGDK.Record;

/**
 * <p>Class displays all detailed informations about all elements of framstick. Only it not 
 * shows all parameters of neurons (here user must get the Prop window).</p>
 * @author Damian Jarzbski
 * @version 1.0
 */
public class Model extends JInternalFrame implements ListSelectionListener, FramstickListener {
	final static String title = I18N.getMessage("ModelProps");
	private Framstick framstick;
	private JTable jPTable = null;
	private JTable jJTable = null;
	private JTable jNTable = null;
	private JTable jCTable = null;
	private JScrollPane jSP = null;
	private DataModel dm = null;
	private static Library library = null;
	int[] mark = { -1, -1, -1, -1 };
	public Action undo = null;
	public Action redo = null;
	boolean framsEvent = false;
	//	************************************************************************************
	/**
	 * <p>Description: Table data model</p>
	 */
	private class DataModel extends AbstractTableModel implements FramstickListener {
		Framstick framstick = null;
		String element = null;
		Record record = null;
		String name = null;
		public DataModel(Framstick fram, String elem) {
			super();
			this.framstick = fram;
			this.framstick.addFramstickListener(this);
			this.element = elem;
		}
		public int getRowCount() {
			if (element.compareTo("p") == 0)
				return framstick.getPartCount();
			else if (element.compareTo("j") == 0)
				return framstick.getJointCount();
			else if (element.compareTo("n") == 0)
				return framstick.getNeuroCount();
			else
				return framstick.getConnCount();
		}
		public int getColumnCount() {
			for (int a = 0; a < Framstick.library.database.size(); a++) {
				record = (Record)Framstick.library.database.get(a);
				name = (String)record.getInfoAbout("id");
				if (name.compareTo(element) == 0)
					return record.parameters.size() + 1;
			}
			return 0;
		}
		public Object getValueAt(int rowIndex, int columnIndex) {
			String id = null;
			if (columnIndex == 0)
				return element + Integer.toString(rowIndex);
			for (int a = 0; a < Framstick.library.database.size(); a++) {
				record = (Record)Framstick.library.database.get(a);
				name = (String)record.getInfoAbout("id");
				if (name.compareTo(element) == 0) {
					id = ((Hashtable)record.parameters.elementAt(columnIndex - 1)).get("id").toString();
				}
			}
			if (element.compareTo("p") == 0)
				return framstick.getPartProp(rowIndex, id);
			else if (element.compareTo("j") == 0)
				return framstick.getJointProp(rowIndex, id);
			else if (element.compareTo("n") == 0)
				return framstick.getNeuroProp(rowIndex, id);
			else
				return framstick.getConnProp(rowIndex, id);
		}
		public String getColumnName(int i) {
			if (i == 0)
				return new String("Name");
			for (int a = 0; a < Framstick.library.database.size(); a++) {
				record = (Record)Framstick.library.database.get(a);
				name = (String)record.getInfoAbout("id");
				if (name.compareTo(element) == 0) {
					return ((Hashtable)record.parameters.elementAt(i - 1)).get(/*name*/
					"id").toString();
				}
			}
			return null;
		}
		public void setValueAt(Object value, int rowIndex, int columnIndex) {
			if (value == null)
				return;
			try {
				if (((String)value).equalsIgnoreCase(""))
					return;
			}
			catch (ClassCastException e) {}
			setTitle(title + " - " + I18N.getMessage("PleaseWait"));
			String id = null;
			if (columnIndex == 0)
				return;
			for (int a = 0; a < Framstick.library.database.size(); a++) {
				record = (Record)Framstick.library.database.get(a);
				name = (String)record.getInfoAbout("id");
				if (name.compareTo(element) == 0) {
					id = ((Hashtable)record.parameters.elementAt(columnIndex - 1)).get("id").toString();
				}
			}
			if (element.compareTo("p") == 0)
				framstick.setPartProp(rowIndex, id, value);
			else if (element.compareTo("j") == 0)
				framstick.setJointProp(rowIndex, id, value);
			else if (element.compareTo("n") == 0)
				framstick.setNeuroProp(rowIndex, id, value);
			else
				framstick.setConnProp(rowIndex, id, value);
			framstick.genotype = framstick.modelToString();
			framstick.rebuildModel();
			framstick.genotype = framstick.modelToString();
			framstick.fireSignificantEditEvent();
			setTitle(title);
		}
		public boolean isCellEditable(int row, int col) {
			if (col == 0) {
				return false;
			}
			return true;
		}
		public Class getColumnClass(int column) {
			if (column == 0)
				return String.class;
			String id = null;
			for (int a = 0; a < Framstick.library.database.size(); a++) {
				record = (Record)Framstick.library.database.get(a);
				name = (String)record.getInfoAbout("id");
				if (name.compareTo(element) == 0) {
					id = ((Hashtable)record.parameters.elementAt(column - 1)).get("id").toString();
				}
			}
			try {
				if (element.compareTo("p") == 0)
					return framstick.getPartProp(0, id).getClass();
				else if (element.compareTo("j") == 0)
					return framstick.getJointProp(0, id).getClass();
				else if (element.compareTo("n") == 0)
					return framstick.getNeuroProp(0, id).getClass();
				else
					return framstick.getConnProp(0, id).getClass();
			}
			catch (NullPointerException e) {
				return Object.class;
			}
		}

		public void significantEdit(FramstickEvent framEvent) {
			this.fireTableChanged(new TableModelEvent(this));
		}
		public void markChanged(FramstickEvent framEvent) {}
	}
	/**
	 * This method picks good column sizes.
	 */
	private void initColumnSizes(JTable table, DataModel model) {
		TableColumn column = null;
		Component comp = null;
		int headerWidth = 0;
		int cellWidth = 0;

		for (int i = 0; i < model.getColumnCount(); i++) {
			column = table.getColumnModel().getColumn(i);

			comp = table.getDefaultRenderer(model.getColumnClass(0)).getTableCellRendererComponent(table, model.getColumnName(i), false, false, 0, 0);
			headerWidth = comp.getPreferredSize().width;

			for (int j = 0; j < model.getRowCount(); j++) {
				comp = table.getDefaultRenderer(model.getColumnClass(i)).getTableCellRendererComponent(table, model.getValueAt(j, i), false, false, j, i);
				cellWidth = Math.max(cellWidth, comp.getPreferredSize().width);
			}

			column.setPreferredWidth(Math.max(headerWidth, cellWidth + 7));
		}
	}
	/**
	 * setting the tooltip with full column name to all columns of <CODE>table</CODE>
	 * @param table - table to set
	 * @param model - model of this table
	 * @param element - element showed in this table
	 */
	public void setToolTip(JTable table, DataModel model, String element) {
		if (!element.equalsIgnoreCase("p") || !element.equalsIgnoreCase("j") || !element.equalsIgnoreCase("n") || !element.equalsIgnoreCase("c"))
			return;
		Record record = null;
		String name = "";
		String text = null;
		int a = 0;
		do {
			record = (Record)Framstick.library.database.elementAt(a);
			name = (String)record.getInfoAbout("id");
			if (a < Framstick.library.database.size() - 1)
				a++;
		}
		while (!name.equalsIgnoreCase(element));
		for (int i = 1; i < model.getColumnCount(); i++) {
			text = ((Hashtable)record.parameters.elementAt(i - 1)).get("name").toString();
			DefaultTableCellRenderer renderer = new DefaultTableCellRenderer();
			renderer.setToolTipText(text);
			table.getColumnModel().getColumn(i).setCellRenderer(renderer);
		}
	}
	private void setTableParams(JTable table) {
		table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
		table.setColumnSelectionAllowed(false);
		table.setRowSelectionAllowed(true);
		table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		table.getSelectionModel().addListSelectionListener(this);
		table.setToolTipText("");
		table.setIntercellSpacing(new Dimension(0, 0));
		table.setRowMargin(0);
		initColumnSizes(table, dm);
	}
	//	**********************************************************************************
	/**
	 * Constructor of Model class
	 */
	public Model(Framstick fr) {
		/*
		 * @param resizable
		 * @param closable
		 * @param maximizable
		 * @param iconifiable
		 */
		super(title, true, true, true, false);
		this.framstick = fr;
		framstick.addFramstickListener(this);
		JTabbedPane tp = new JTabbedPane();
		//parts
		jSP = new JScrollPane();
		dm = new DataModel(framstick, "p");
		TableSorter sorter = new TableSorter(dm);
		jPTable = new JTable(sorter);
		sorter.addMouseListenerToHeaderInTable(jPTable);
		setTableParams(jPTable);
		setToolTip(jPTable, dm, "p");
		jSP.getViewport().add(jPTable);

		tp.addTab(I18N.getMessage("Parts"), jSP);
		//joints
		jSP = new JScrollPane();
		dm = new DataModel(framstick, "j");
		sorter = new TableSorter(dm);
		jJTable = new JTable(sorter);
		setTableParams(jJTable);
		setToolTip(jJTable, dm, "j");
		jSP.getViewport().add(jJTable);
		tp.addTab(I18N.getMessage("Joints"), jSP);
		//neurons
		jSP = new JScrollPane();
		dm = new DataModel(framstick, "n");
		sorter = new TableSorter(dm);
		jNTable = new JTable(sorter);
		sorter.addMouseListenerToHeaderInTable(jNTable);
		setTableParams(jNTable);
		setToolTip(jNTable, dm, "n");
		jSP.getViewport().add(jNTable);
		tp.addTab(I18N.getMessage("Neurons"), jSP);
		//connections
		jSP = new JScrollPane();
		dm = new DataModel(framstick, "c");
		sorter = new TableSorter(dm);
		jCTable = new JTable(sorter);
		sorter.addMouseListenerToHeaderInTable(jCTable);
		setTableParams(jCTable);
		setToolTip(jCTable, dm, "c");
		jSP.getViewport().add(jCTable);
		tp.addTab(I18N.getMessage("Connections"), jSP);

		this.getContentPane().add(tp);
		this.setSize(new Dimension(450, 400));
		this.setDefaultCloseOperation(JInternalFrame.DISPOSE_ON_CLOSE);
		undo = new AbstractAction(I18N.getMessage("Undo"), new ImageIcon(ClassLoader.getSystemResource("images/Undo24.gif"))) {
			public void actionPerformed(ActionEvent e) {
				if (framstick.undo()) {
					framstick.fireSignificantEditEvent();
				}
			}
		};
		redo = new AbstractAction(I18N.getMessage("Redo"), new ImageIcon(ClassLoader.getSystemResource("images/Redo24.gif"))) {
			public void actionPerformed(ActionEvent e) {
				if (framstick.redo()) {
					framstick.fireSignificantEditEvent();
				}
			}
		};
	}
	//======================================================================
	/**
	 * Main function to test this window
	 * @param args
	 */
	public static void main(String[] args) {
		ErrManager err = new ErrManager();
		library = null;
		//jGDK-----------
		try {
			File f = new File("model.def");
			if (!f.exists()) {
				System.out.println("The config file don't exist: " + "model.def");
				return;
			}
			if (!f.canRead()) {
				System.out.println("There is no access to the config file: " + "model.def");
				return;
			}
			InputStream input = new FileInputStream(f);
			int n = input.available();
			byte buf[] = new byte[n];
			if ((n = input.read(buf)) >= 0) {
				System.out.println("The config file has been read");
			}
			input.close();
			library = new Library(new String(buf));
		}
		catch (IOException ex) {
			System.out.println("ERROR: " + ex);
		}
		Framstick.library = library;
		GenotypeParser.library = library;
		Framstick fram = new Framstick();
		fram.genotype = "//0\np:\np:\np:\nj:0,1\n";
		fram.rebuildModel();
		for (int x = 0; x < ErrManager.msg.size(); x++) {
			System.out.println("-->" + ((Message)ErrManager.msg.get(x)).description);
		}
		System.out.println(fram);
		Model m = new Model(fram);
		m.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		m.pack();
		JFrame f = new JFrame("Fred - main frame");
		f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		f.getContentPane().setLayout(null);
		f.getContentPane().add(m);
		f.setSize(400, 300);
		f.setVisible(true);
		try {
			m.setMaximum(true);
		}
		catch (PropertyVetoException e) {
			System.out.println("ERROR: Cannot maximize the model window");
		}
		m.setVisible(true);
	}
	//	======================================================================
	/**
	 * Change the selection in framstick model due to selection in the table.
	 */
	public void valueChanged(ListSelectionEvent e) {
		if (!e.getValueIsAdjusting()) {
			System.out.print("Zaznaczono: ");
			if (e.getSource().equals(jPTable.getSelectionModel())) {
				System.out.println("Part" + jPTable.getSelectedRow());
				for(int i=0; i<framstick.getPartCount(); i++)
				framstick.unmarkPart(i);
				if(jPTable.getSelectedRow() >= 0)framstick.markPart(jPTable.getSelectedRow());
				mark[0] = jPTable.getSelectedRow();
			}
			else if (e.getSource().equals(jJTable.getSelectionModel())) {
				System.out.println("Joint" + jJTable.getSelectedRow());
				for(int i=0; i<framstick.getJointCount(); i++)
				framstick.unmarkJoint(i);
				if(jJTable.getSelectedRow() >= 0)framstick.markJoint(jJTable.getSelectedRow());
				mark[1] = jJTable.getSelectedRow();
			}
			else if (e.getSource().equals(jNTable.getSelectionModel())) {
				System.out.println("Neuron" + jNTable.getSelectedRow());
				for(int i=0; i<framstick.getNeuroCount(); i++)
				framstick.unmarkNeuron(i);
				if(jNTable.getSelectedRow() >= 0)framstick.markNeuron(jNTable.getSelectedRow());
				mark[2] = jNTable.getSelectedRow();
			}
			else if (e.getSource().equals(jCTable.getSelectionModel())) {
				System.out.println("Connection" + jCTable.getSelectedRow());
				for(int i=0; i<framstick.getConnCount(); i++)
				framstick.unmarkConnection(i);
				if(jCTable.getSelectedRow() >= 0)framstick.markConnection(jCTable.getSelectedRow());
				mark[3] = jPTable.getSelectedRow();
			}
			if(!framsEvent){
			framstick.fireMarkChangedEvent();
				}else
		framsEvent = false;
		}
	}
/**
 * Selecting the apropriate row in table exact to this in framstick.
 */
	public void markChanged(FramstickEvent framEvent) {
/*		framsEvent = true;
		System.out.println("Model - markEvent");
		for (int i = 0; i < framstick.getPartCount(); i++)
			if (framstick.elementStrongSelected("p", i))
				jPTable.setRowSelectionInterval(i, i);
		for (int i = 0; i < framstick.getJointCount(); i++)
			if (framstick.elementStrongSelected("j", i))
				jJTable.setRowSelectionInterval(i, i);
		for (int i = 0; i < framstick.getNeuroCount(); i++)
			if (framstick.elementStrongSelected("n", i))
				jNTable.setRowSelectionInterval(i, i);
		for (int i = 0; i < framstick.getConnCount(); i++)
			if (framstick.elementStrongSelected("c", i))
				jCTable.setRowSelectionInterval(i, i);
*/	}
	public void significantEdit(FramstickEvent framEvent) {
		jPTable.revalidate();
		jJTable.revalidate();
		jNTable.revalidate();
		jCTable.revalidate();
/*		framsEvent = true;
		System.out.println("Model - signif edit");
		for (int i = 0; i < framstick.getPartCount(); i++)
			if (framstick.elementStrongSelected("p", i))
				jPTable.setRowSelectionInterval(i, i);
		for (int i = 0; i < framstick.getJointCount(); i++)
			if (framstick.elementStrongSelected("j", i))
				jJTable.setRowSelectionInterval(i, i);
		for (int i = 0; i < framstick.getNeuroCount(); i++)
			if (framstick.elementStrongSelected("n", i))
				jNTable.setRowSelectionInterval(i, i);
		for (int i = 0; i < framstick.getConnCount(); i++)
			if (framstick.elementStrongSelected("c", i))
				jCTable.setRowSelectionInterval(i, i);
*/	}
	protected void finalize() throws Throwable {
		System.out.println("Finalizing model window");
		this.getContentPane().removeAll();
		framstick.removeFramstickListener(this);
		framstick = null;
		jPTable.getSelectionModel().removeListSelectionListener(this);
		jJTable.getSelectionModel().removeListSelectionListener(this);
		jNTable.getSelectionModel().removeListSelectionListener(this);
		jCTable.getSelectionModel().removeListSelectionListener(this);
		jPTable = null;
		jJTable = null;
		jNTable = null;
		jCTable = null;
		jSP = null;
		dm = null;
		library = null;
		mark = null;
		undo = null;
		redo = null;
		super.finalize();
	}
}
