package fred;

import idx3d.idx3d_3ds_Importer;
import idx3d.idx3d_Light;
import idx3d.idx3d_Material;
import idx3d.idx3d_Math;
import idx3d.idx3d_Object;
import idx3d.idx3d_ObjectFactory;
import idx3d.idx3d_Scene;
import idx3d.idx3d_Texture;
import idx3d.idx3d_Vector;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.event.MouseWheelEvent;
import java.awt.event.MouseWheelListener;
import java.io.IOException;
import java.net.URL;

import javax.swing.JPanel;

import jGDK.Framstick;
import jGDK.FramstickEvent;
import jGDK.FramstickListener;

public class Neuro extends JPanel implements MouseListener, MouseMotionListener, MouseWheelListener
{
	Framstick fram;
	idx3d_Scene scene;	//podstawowa zmienna dla trybu graficznego :)
	int oldx=0;			//na podstawie tych dwoch zmiennych i polozenia myszki
	int oldy=0;			//bedziemy manipulowac scena
	float centralPoint[] = { 0, 0, 0 };	//srodek do centrowania modelu
	float networkSize[] = { 0, 0, 0 }; //do box'a i zasiegu kamery
	idx3d_Material czerwony = new idx3d_Material(0xFF0000);//E91815);	//czerwony
	idx3d_Material zielony = new idx3d_Material(0x99FF00);//8512);	//zielony
	idx3d_Material czarny = new idx3d_Material(0x0022);		//czarny
	idx3d_Material bialy = new idx3d_Material(0xa0a065);//0022);		//czarny (bedzie przezroczysty)
	//idx3d_Texture tlo = idx3d_TextureFactory.SKY(400,400,3);
	idx3d_Texture tlo = new idx3d_Texture(ClassLoader.getSystemResource("images/tlo.png"),"tlo.png");
	float view = 0;		 //pozycja kamery
	float lookAtX = 0;	 //gdzie patrzy kamera
	float lookAtY = 0;
	String markedNeuron = null;			//nazwa "scenowa" zaznaczonego neuronu
	String markedNeuronShort = null;	//numer zaznaczonego neuronu
	Dimension d;						//wymiary okna
	String description0 = "";			//3 linie do opisania zaznaczonego neuronu
	String description1 = "";
	String description2 = "";
	boolean sortNeurons = false;		//jaki rodzaj rozmieszczenia wybieramy
	int oldSizeX = 0;					//rozmiary okna
	int oldSizeY = 0;					//dla zmiany rozmiarow sceny
	int animProg = 0;					//postep w animacji
	int animDir = 1;					//kierunek animacji
	boolean animation = false;			//czy animujemy
	boolean transparencyAdd = false;	//w ktora strone transparency
	idx3d_Object neuron3dsG = null;
	idx3d_Object neuron3dsU = null;
	idx3d_Object neuron3dsT = null;
	idx3d_Object neuron3dsS = null;
	idx3d_Object neuron3dsbend = null;
	idx3d_Object neuron3dsM = null;
//----- tutaj roboczy fragmencik kodu z danymi i elementach ciala Framsticka
//format: wsp.x, wsp.y, id_part, id_joint, typ_neuronu
//format: do, od, waga

	Neuro(Framstick model)
	{		
		fram = model;
		fram.addFramstickListener(new MyFramstickListener());
		setNeuronsPos();			//ustalenie poczatkowej pozycji neuronow
		buildCenter();				//zbudowanie wsp. srodka sceny
		prepareScene();				//ustawienie parametrow sceny
		createLights();				//ustawienie swiatel
		addObjectsToScene();		//dodanie elementow do sceny
		//bialy.setTransparency(255); //przezroczystosc niezaznaczonych polaczen
/*		Button button1 = new Button("Zoom in "); //batony :)
        add(button1);
		Button button2 = new Button("Zoom out");
		add(button2);
		Button button3 = new Button("Default ");
		add(button3);
		Button button4 = new Button("Network ");
		add(button4);
		Button button5 = new Button("Animate ");
		add(button5);
*/		this.addMouseListener(this);
		this.addMouseMotionListener(this);
		this.addMouseWheelListener(this);
		this.setMinimumSize(new Dimension(40,40));
	}

//----- wywolywana za kazdym razem, gdy zawartosc okna musi zostac ponownie wyswietlona

	public synchronized void paint(Graphics g)
	{
		update(g);
	}

//----- wywolywana, gdy applet zada ponownego wyswietlenia fragmentu jego okna

	public synchronized void update(Graphics g)
	{
		d = getSize();								//pobiera rozmiar appletu
		if (d.width!=oldSizeX || d.height!=oldSizeY)//jesli dawne rozmiary sa
		{											//inne niz aktualne
			oldSizeX = d.width;						//to zapamietuje rozmiar apletu
			oldSizeY = d.height;
			scene.resize(oldSizeX, oldSizeY-32);	//i dopasowuje rozmiar sceny 
		}											//do wymiarow okna
		if(animation) { neuronsAnimation(); repaint(); } //przebudowa tylko podczas animacji
		scene.render();				        	//renderuje scene do bufora
		g.drawImage(scene.getImage(),0,0,null);	//wyswietla otrzymany obraz
	    g.setColor(new Color(0x000000ff));		//wypelnia na niebiesko
	    g.fillRect(0,d.height-32,d.width,d.height);//prostokat w dole ekranu
		g.setColor(new Color(0x00ffffff));		//a na bialo wypisuje
		g.drawString(description0,10,d.height-22);//opis zaznaczonego neuronu
		g.drawString(description1,10,d.height-12);
		g.drawString(description2,10,d.height-2);
	}

//----- procedura tworzaca scene i ustalajaca jej podstawowe parametry

	public void prepareScene()
	{
		scene=new idx3d_Scene(this.getSize().width,this.getSize().height-32);//rozmiary
		scene.useIdBuffer(true);		//do identyfikacji obiektow
		scene.environment.setBackground(tlo);//0xF2E7D9);
		defaultCameraPos();				//pozycja kamery
	}

//----- tutaj z kolei zajmiemy sie parametrami swiatel

	public void createLights()
	{
		scene.addLight("Light1",new idx3d_Light(new idx3d_Vector(0.2f,0.2f,1f),0xFFFFFF,320,120));			
		scene.addLight("Light2",new idx3d_Light(new idx3d_Vector(-1f,-1f,1f),0xFFCC99,160,200));
	}

//-- tworzenie obiektow, dodawanie ich do sceny, ustalenie materialu i pozycji obiektow

	public void addObjectsToScene()
	{
		for(int i=0; i<fram.getNeuroCount(); i++)
		{//rysujemy neurony
			drawNeuron(i, ((Float)fram.getNeuroProp(i,"x")).floatValue(), ((Float)fram.getNeuroProp(i,"y")).floatValue());//[wiersz][kolumna]
		}
		for(int i=0; i<fram.getConnCount(); i++)
		{//a potem polaczenia
			drawConnection(i, ((Integer)fram.getConnProp(i,"n")).intValue(), ((Integer)fram.getConnProp(i,"i")).intValue());
		}	
	}

	public void removeObjectsFromScene()
	{//usuwamy wszystko ze sceny
		scene.removeAllObjects();
	}

//-------------------------------------------------------------------------
//---koniec ze scena--czas na szopki zwiazane z rozmieszczaniem neuronow---
//-------------------------------------------------------------------------

/*	public void setAllNeurons()//ladne, posortowane
	{
		for(int i=0; i<fram.getNeuroCount(); i++)
		{
			fram.setNeuroProp(i,"x",new Float(Float.POSITIVE_INFINITY));
			fram.setNeuroProp(i,"y",new Float(Float.POSITIVE_INFINITY));
			if (fram.getNeuroProp(i,"f") == null) // dodane
			{		
				fram.setNeuroProp(i, "f", new Integer(-1)); continue;
			}
			if(((Integer)fram.getNeuroProp(i,"f")).intValue()==-2) fram.setNeuroProp(i,"f",new Integer(-1));

		}
		for(int i=0; i<fram.getConnCount(); i++) setNeuronPos(((Integer)fram.getConnProp(i,"n")).intValue());
		//nastepnie bierzemy sie za "wolne" neurony
		for(int i=0; i<fram.getNeuroCount(); i++) setNeuronPos(i);

	}
*/
	public void setNeuronPos(int number)
	{
		if(((Integer)fram.getNeuroProp(number,"f")).intValue()==-2) return;//jezeli wspolrzedne nie byly ustawiane to probujemy w (0,0) i okolicy
		if(((Float)fram.getNeuroProp(number,"x")).floatValue()==Float.POSITIVE_INFINITY) 
		{
			for(int trial=0; ;trial++)//do oporu, az sie uda
			{
				if(setNeuronCoordinates(number, 0, -trial))//ustawienie wsp. 
				{//jak ustawienie udane, to zmieniamy flage
					if(((Integer)fram.getNeuroProp(number,"f")).intValue()==-1) fram.setNeuroProp(number,"f",new Integer(-2));
					break;
				}
			}
		}
		//a potem (niezaleznie od w/w bierzemy sie za poprzedniki
		for(int i=0; i<fram.getConnCount(); i++)//sprawdzamy wszystkie polaczenia
		{
			if(((Integer)fram.getNeuroProp(number,"f")).intValue()==-1) fram.setNeuroProp(number,"f",new Integer(-2));
			if(((Integer)fram.getConnProp(i,"n")).intValue()==number && ((Integer)fram.getConnProp(i,"i")).intValue()!=number)
			{//jezeli neuron ma poprzednika
				setAsInput(((Integer)fram.getConnProp(i,"i")).intValue(),number);//ustawienie go tez jako wejsice
				setNeuronPos(((Integer)fram.getConnProp(i,"i")).intValue());//i ustawienie pozycji poprzednika
			}
		}
	}
//!	
	public void setAsInput(int innumber, int outnumber)//ustawienie neuronu jako poprzednika
	{
		if(((Float)fram.getNeuroProp(innumber,"x")).floatValue()!=Float.POSITIVE_INFINITY) return;
		//jezeli wspolrzedne byly ustawiane to ich juz nie zmieniamy
		if(setNeuronCoordinates(innumber, ((Float)fram.getNeuroProp(outnumber,"x")).floatValue()-1, ((Float)fram.getNeuroProp(outnumber,"y")).floatValue())) return;
		//probujemy ustawic bezposrednio za nastepnikiem
		for(int trial=1;;trial++)//jak nie daje rady, to probujemy na kolejnych pozycjach
		{						 //oddalajac sie co krok o jedna wspolrzedna
			if(setNeuronCoordinates(innumber, ((Float)fram.getNeuroProp(outnumber,"x")).floatValue()-1, ((Float)fram.getNeuroProp(outnumber,"y")).floatValue()-trial)) return;
			if(setNeuronCoordinates(innumber, ((Float)fram.getNeuroProp(outnumber,"x")).floatValue()-1, ((Float)fram.getNeuroProp(outnumber,"y")).floatValue()+trial)) return;
		}
	}

	public boolean setNeuronCoordinates(int number, float x, float y)
	{//ustawia wspolrzedne neuronu
		for(int j=0; j<fram.getNeuroCount(); j++)
		{
			if(((Float)fram.getNeuroProp(j,"x")).floatValue()==x && ((Float)fram.getNeuroProp(j,"y")).floatValue()==y) 
			{
				return false;//jesli wspolrzedne zajete przez inny neuron to lipa
			}
		}
		fram.setNeuroProp(number,"x", new Float(x));
		fram.setNeuroProp(number,"y", new Float(y));//ew. new Integer((int)y)
		return true;
	}

// rozmieszczenie w kwadracie o boku dlugosci a=sqrt(N)

	public void setNeuronsPos()
	{
		int a = ((int)(Math.sqrt(fram.getNeuroCount())-0.0001))+1;
		int numer = 0;
		for(int i=0; i<a; i++)
			for(int j=0; j<a; j++)
			{
				fram.setNeuroProp(numer,"x",new Float(i));
				fram.setNeuroProp(numer,"y",new Float(j));
				numer++;
				if (numer==fram.getNeuroCount()) return;
			}
	}

//tutaj decydujemy o sposobie rozmieszczenia sieci (jak 1 to 2, a jak 2 to 1)

	public void changePlacingMethod()
	{
		if(sortNeurons) 
		{
			setNeuronsPos();
			sortNeurons = false;
		}
		else 
		{
			setAllNeurons();
			sortNeurons = true;
		}
		redrawScene();
	}

//przerysowanie sceny (konieczne, by po zmianie ustawienia neuronow byly one widoczne

	public void redrawScene()
	{
		removeObjectsFromScene();
		buildCenter();
		prepareScene();
		createLights();
		markedNeuron = null;			//na odbudowanej scenie nie ma 
		markedNeuronShort = null;	    //zadnego zaznaczonego obiektu
		animProg = 0;					//postep w animacji
		animDir = 1;					//kierunek animacji
		addObjectsToScene();			//ustawiamy default, zeby rysunki sie nie rozlazly
		scene.rebuild();				//w koncu scena sie przestawia na default
	}

//-------------------------------------------------------------------------
//----skoro juz rozmieszczamy neurony, to teraz je rysujmy wraz z reszta---
//-------------------------------------------------------------------------

	public void drawNeuron(int i, float x, float y)//podejmuje decyzje o szczegolach rysunku
	{
		String zmienna = "" + fram.getNeuroProp(i,"d");
		if (zmienna.equals("G")) drawGyroscope(i, x, y);//umieszczenie zyroskopu
		else if (zmienna.equals("T")) drawTouch(i,x,y);//receptor dotykowy
		else if (zmienna.equals("S")) drawSmell(i,x,y);//receptor wechu
		else if (zmienna.equals("@")) drawRotMuscle(i,x,y);//neuron o stalej wartosci
		else if (zmienna.equals("|")) drawBendMuscle(i,x,y);//miesien 
		else drawUnknown(i,x,y);//reszta niezdefiniowana
	}

	public void drawGyroscope(int i, float x, float y)//rysuje zyroskop
	{
		try
		{
			URL u = ClassLoader.getSystemResource("3DS/neuro-G.3ds");//jarzbi
			new idx3d_3ds_Importer().importFromStream(u.openStream(),this.scene);
		}
		catch(IOException e)
		{
			System.out.println("Unable to download 3ds files!");
		}
		neuron3dsG = scene.object("cylinder");//podstawienie importu
		scene.removeObject("cylinder");//usuwamy import ze sceny
		neuron3dsG.setMaterial(new idx3d_Material(0xEEEEEE));//kolor
		//neuron3dsG.scale(0.3f);//skalowanie dla proporcji
		//neuron3dsG.name = "Neuron"+numerekWliczniku;//podanie tymczasowej nazwy
		//neuroniki[numerekWliczniku] = neuron3dsG;//dodanie do tablicy obiektow
		//dodanie elementu do sceny
		scene.addObject("Neuron"+i+"__",neuron3dsG);
		scene.object("Neuron"+i+"__").setPos(x-0.45f, y, -0.05f);
	}

	public void drawTouch(int i, float x, float y)//rysuje receptor dotyku
	{
		try
		{
			URL u = ClassLoader.getSystemResource("3DS/neuro-T.3ds");//jarzbi
			new idx3d_3ds_Importer().importFromStream(u.openStream(),this.scene);
		}
		catch(IOException e)
		{
			System.out.println("Unable to download 3ds files!");
		}
		neuron3dsT = scene.object("closedline");//podstawienie importu
		scene.removeObject("closedline");//usuwamy import ze sceny
		neuron3dsT.setMaterial(new idx3d_Material(0x000000));//kolor
		neuron3dsT.rotate(0,0,-idx3d_Math.pi/2);
		neuron3dsT.scale(1.5f);//skalowanie dla proporcji
		//neuron3dsG.name = "Neuron"+numerekWliczniku;//podanie tymczasowej nazwy
		//neuroniki[numerekWliczniku] = neuron3dsG;//dodanie do tablicy obiektow
		//dodanie elementu do sceny
		scene.addObject("Neuron"+i+"__",neuron3dsT);
		scene.object("Neuron"+i+"__").setPos(x+0.1f, y-0.2f, -0.05f);
	}

	public void drawSmell(int i, float x, float y)//rysuje receptor zapachu
	{
		try
		{
			URL u = ClassLoader.getSystemResource("3DS/neuro-S.3ds");//jarzbi
			new idx3d_3ds_Importer().importFromStream(u.openStream(),this.scene);
		}
		catch(IOException e)
		{
			System.out.println("Unable to download 3ds files!");
		}
		neuron3dsS = scene.object("closedline");//podstawienie importu
		scene.removeObject("closedline");//usuwamy import ze sceny
		neuron3dsS.setMaterial(new idx3d_Material(0xFF5500));//kolor
		neuron3dsS.scale(1.5f);//skalowanie dla proporcji
		//neuron3dsG.name = "Neuron"+numerekWliczniku;//podanie tymczasowej nazwy
		//neuroniki[numerekWliczniku] = neuron3dsG;//dodanie do tablicy obiektow
		//dodanie elementu do sceny
		scene.addObject("Neuron"+i+"__",neuron3dsS);
		scene.object("Neuron"+i+"__").setPos(x, y-0.25f, -0.05f);
	}

	public void drawRotMuscle(int i, float x, float y)//rysuje miesien zginajacy
	{
		try
		{
			URL u = ClassLoader.getSystemResource("3DS/neuro-@.3ds");//jarzbi
			new idx3d_3ds_Importer().importFromStream(u.openStream(),this.scene);
		}
		catch(IOException e)
		{
			System.out.println("Unable to download 3ds files!");
		}
		neuron3dsM = scene.object("line");//podstawienie importu
		scene.removeObject("line");//usuwamy import ze sceny
		neuron3dsM.setMaterial(new idx3d_Material(0xFF0000));//kolor
		neuron3dsM.rotate(0,idx3d_Math.pi/2,0);
		//neuron3dsM.scale(0.3f);//skalowanie dla proporcji
		//neuron3dsG.name = "Neuron"+numerekWliczniku;//podanie tymczasowej nazwy
		//neuroniki[numerekWliczniku] = neuron3dsG;//dodanie do tablicy obiektow
		//dodanie elementu do sceny
		scene.addObject("Neuron"+i+"__",neuron3dsM);
		scene.object("Neuron"+i+"__").setPos(x, y, -0.05f);
	}

	public void drawBendMuscle(int i, float x, float y)//rysuje miesien zginajacy
	{
		try
		{
			URL u = ClassLoader.getSystemResource("3DS/neuro-bend.3ds");//jarzbi
			new idx3d_3ds_Importer().importFromStream(u.openStream(),this.scene);
		}
		catch(IOException e)
		{
			System.out.println("Unable to download 3ds files!");
		}
		neuron3dsbend = scene.object("line");//podstawienie importu
		scene.removeObject("line");//usuwamy import ze sceny
		neuron3dsbend.setMaterial(new idx3d_Material(0xFF0000));//kolor
		//neuron3dsbend.scale(0.3f);//skalowanie dla proporcji
		//neuron3dsG.name = "Neuron"+numerekWliczniku;//podanie tymczasowej nazwy
		//neuroniki[numerekWliczniku] = neuron3dsG;//dodanie do tablicy obiektow
		//dodanie elementu do sceny
		scene.addObject("Neuron"+i+"__",neuron3dsbend);
		scene.object("Neuron"+i+"__").setPos(x-0.15f, y, -0.05f);
	}

	public void drawUnknown(int i, float x, float y)//rysuje miesien zginajacy
	{
		try
		{
			URL u = ClassLoader.getSystemResource("3DS/neuro-U.3ds");//jarzbi	
			new idx3d_3ds_Importer().importFromStream(u.openStream(),this.scene);//u.openStream()("3DS/neuro-U.3ds"),this.scene);
		}
		catch(IOException e)
		{
			System.out.println("Unable to download 3ds files from url:"+e.getMessage());
		}
		neuron3dsU = scene.object("box");//podstawienie importu
		scene.removeObject("box");//usuwamy import ze sceny
		neuron3dsU.setMaterial(new idx3d_Material(0xEEEEE));//kolor
		//neuron3dsU.scale(0.3f);//skalowanie dla proporcji
		//neuron3dsG.name = "Neuron"+numerekWliczniku;//podanie tymczasowej nazwy
		//neuroniki[numerekWliczniku] = neuron3dsG;//dodanie do tablicy obiektow
		//dodanie elementu do sceny
		scene.addObject("Neuron"+i+"__",neuron3dsU);
		scene.object("Neuron"+i+"__").setPos(x, y, -0.05f);
	}


	public void neuronsAnimation()//do animowania neuronow
	{//trial
		if(markedNeuronShort==null) return;
		int NeuronNumber = Integer.valueOf(markedNeuronShort).intValue();
		//System.out.println(NeuronNumber);
		if(zielony.getTransparency()>245) transparencyAdd = false;
		if(zielony.getTransparency()<10) transparencyAdd = true;
		if(transparencyAdd)
		{
			zielony.setTransparency(zielony.getTransparency()+7);
			czerwony.setTransparency(czerwony.getTransparency()-7);
		}
		else
		{
			zielony.setTransparency(zielony.getTransparency()-7);
			czerwony.setTransparency(czerwony.getTransparency()+7);
		}
/*for(int i=0; i<fram.getConnCount(); i++)
{
	if(((Integer)fram.getConnProp(i,"i")).intValue()!=NeuronNumber) continue;
	if(scene.object("Connection"+fram.getConnProp(i,"n")+":"+NeuronNumber+"_"+0)==null) continue;
	scene.object("Connection"+fram.getConnProp(i,"n")+":"+NeuronNumber+"_"+0).rotateSelf(-idx3d_Math.pi/12,0,0);
	if(scene.object("Connection"+fram.getConnProp(i,"n")+":"+NeuronNumber+"_"+1)==null) continue;
	else //System.out.println("Mamy polaczenie lamane");
	{
		scene.object("Connection"+fram.getConnProp(i,"n")+":"+NeuronNumber+"_"+1).rotateSelf(0,-idx3d_Math.pi/12,0);
		scene.object("Connection"+fram.getConnProp(i,"n")+":"+NeuronNumber+"_"+2).rotateSelf(-idx3d_Math.pi/12,0,0);
		scene.object("Connection"+fram.getConnProp(i,"n")+":"+NeuronNumber+"_"+3).rotateSelf(0,-idx3d_Math.pi/12,0);
		scene.object("Connection"+fram.getConnProp(i,"n")+":"+NeuronNumber+"_"+4).rotateSelf(-idx3d_Math.pi/12,0,0);
	}
}*/
		//float x1 = ((Float)fram.getNeuroProp(n1,"x")).floatValue();//wspolrzedne obu neuronow
		//float x2 = ((Float)fram.getNeuroProp(n2,"x")).floatValue();
		//float y1 = ((Float)fram.getNeuroProp(n1,"y")).floatValue();
		//float y2 = ((Float)fram.getNeuroProp(n2,"y")).floatValue();
	}

//rysowanie polaczenia

	public void drawConnection(int i, int n1, int n2)	//format do, od
	{
		float x1 = ((Float)fram.getNeuroProp(n1,"x")).floatValue();//wspolrzedne obu neuronow
		float x2 = ((Float)fram.getNeuroProp(n2,"x")).floatValue();
		float y1 = ((Float)fram.getNeuroProp(n1,"y")).floatValue();
		float y2 = ((Float)fram.getNeuroProp(n2,"y")).floatValue();
		//wyjscie
		if (x1==x2+1 && y1==y2)//bezposredni poprzednik
		{					   //to rysujemy jedna kreseczke i return	
			idx3d_Object connection1 = idx3d_ObjectFactory.BOX(0.6f,0.07f,0.07f);
			scene.addObject("Connection" + n1 + ":" + n2 + "_" + 0, connection1);
			scene.object("Connection" + n1 + ":" + n2 + "_" + 0).setMaterial(bialy);
			connection1.setPos(x2+0.5f,y2,0);
			return;
		}
		else 	//zwykle wyjscie neuronu
		{
			idx3d_Object connection2 = idx3d_ObjectFactory.BOX(0.2f,0.07f,0.07f);
			scene.addObject("Connection" + n1 + ":" + n2 + "_" + 0, connection2);
			scene.object("Connection" + n1 + ":" + n2 + "_" + 0).setMaterial(bialy);
			connection2.setPos(x2+0.3f,y2,0);
		}
		//krotki w pionie
		idx3d_Object connection3 = idx3d_ObjectFactory.BOX(0.07f,0.49f,0.07f);
		scene.addObject("Connection" + n1 + ":" + n2 + "_" + 1, connection3);
		scene.object("Connection" + n1 + ":" + n2 + "_" + 1).setMaterial(bialy);
		if (y1>=y2)	connection3.setPos(x2+0.4f,y2+0.23f,0);
		else connection3.setPos(x2+0.4f,y2-0.23f,0);
		//poziom (ten jest nieco dluzszy) :)
		float length = (float)Math.sqrt(  ((x2+0.4f)-(x1-0.4f))*((x2+0.4f)-(x1-0.4f)) );
		float cpoint = 0;
		if (x2>=x1)
		{
			cpoint = (x1-0.4f)+((x2+0.4f)-(x1-0.4f))/2;
		}
		else
		{
			cpoint = (x2+0.4f)+((x1-0.4f)-(x2+0.4f))/2; 
		}
		idx3d_Object connection4 = idx3d_ObjectFactory.BOX(length,0.07f,0.07f);
		scene.addObject("Connection" + n1 + ":" + n2 + "_" + 2, connection4);
		scene.object("Connection" + n1 + ":" + n2 + "_" + 2).setMaterial(bialy);
		if (y1>=y2) connection4.setPos(cpoint, y2+0.46f, 0);
		else connection4.setPos(cpoint, y2-0.46f, 0);
		//kolejny w pionie
		if (y1>=y2) length = y1 - (y2+0.44f);
		else length = y2 - (y1+0.44f);
		idx3d_Object connection5 = idx3d_ObjectFactory.BOX(0.07f,length,0.07f);
		scene.addObject("Connection"+ n1 + ":" + n2 + "_" + 3, connection5);
		scene.object("Connection" + n1 + ":" + n2 + "_" + 3).setMaterial(bialy);
		if (y1>=y2)	connection5.setPos(x1-0.4f,y1-length/2+0.01f,0);
		else connection5.setPos(x1-0.4f,y1+length/2-0.01f,0);
		//wejscie
		idx3d_Object connection6 = idx3d_ObjectFactory.BOX(0.2f,0.07f,0.07f);
		scene.addObject("Connection" + n1 + ":" + n2 + "_" + 4, connection6);
		scene.object("Connection" + n1 + ":" + n2 + "_" + 4).setMaterial(bialy);
		connection6.setPos(x1-0.3f,y1,0);
	}

//-------------------------------------------------------------------------
//------jak juz wszystko umiemy narysowac, zajmijmy sie kamera-------------
//-------------------------------------------------------------------------

	public void defaultCameraPos()//ustawienie domyslnej pozycji kamery
	{
		view = (float)Math.sqrt(networkSize[0]*networkSize[0] + networkSize[1]*networkSize[1]) ;//+ 2;
		scene.defaultCamera.lookAt(centralPoint[0],centralPoint[1],0);
		scene.defaultCamera.setPos(centralPoint[0],centralPoint[1], -view);
	}

	public void zoomIn()//zblizenie
	{
		if (view>2) view-=0.5;								
		scene.defaultCamera.setPos(lookAtX,lookAtY,-view);  //zmiana pozycji
		scene.defaultCamera.lookAt(lookAtX,lookAtY,0);		//i pkt. patrzenia
	}

	public void zoomOut()//oddalenie
	{
		view+=0.5;
		scene.defaultCamera.setPos(lookAtX,lookAtY,-view);	//zmiana pozycji
		scene.defaultCamera.lookAt(lookAtX,lookAtY,0);		//i pkt. patrzenia
	}

//budowanie srodka sceny (czyli gdzie powinna byc skierowana kamera)

	public void buildCenter()
	{
		float maxPoint[] = { Float.NEGATIVE_INFINITY, 
					         Float.NEGATIVE_INFINITY };
		float minPoint[] = { Float.POSITIVE_INFINITY,
			                 Float.POSITIVE_INFINITY };
		for(int i=0; i<fram.getNeuroCount(); i++)//ustalenie maksymalnych wychylen w kazda strone
		{
			if (((Float)fram.getNeuroProp(i,"x")).floatValue() > maxPoint[0]) maxPoint[0] = ((Float)fram.getNeuroProp(i,"x")).floatValue();
			if (((Float)fram.getNeuroProp(i,"y")).floatValue() > maxPoint[1]) maxPoint[1] = ((Float)fram.getNeuroProp(i,"y")).floatValue();
			if (((Float)fram.getNeuroProp(i,"x")).floatValue() < minPoint[0]) minPoint[0] = ((Float)fram.getNeuroProp(i,"x")).floatValue();
			if (((Float)fram.getNeuroProp(i,"y")).floatValue() < minPoint[1]) minPoint[1] = ((Float)fram.getNeuroProp(i,"y")).floatValue();
		}
		this.centralPoint[0] = (minPoint[0] + ((maxPoint[0] - minPoint[0])/2));
		this.centralPoint[1] = (minPoint[1] + ((maxPoint[1] - minPoint[1])/2));
		this.lookAtX = this.centralPoint[0];//obliczenie srodka
		this.lookAtY = this.centralPoint[1];//i skierowanie tam kamery		

		this.networkSize[0] = maxPoint[0] - minPoint[0] + 1;//ustalenie rozmiarow sieci
		this.networkSize[1] = maxPoint[1] - minPoint[1] + 1;
	}

//-------------------------------------------------------------------------
//------tutaj operacje wykonywane przy zaznaczaniu neuronu-----------------
//-------------------------------------------------------------------------

	public void changeColors(idx3d_Object obiekt)//zmiana koloru neuronu
	{											 //i incydentnych z nim polaczen
		if (markedNeuron!=null)//jesli nic nie zaznaczono
		{
			for(int i=0; i<scene.objects; i++)//sprawdzamy wszystkie obiekty sceny
			{//gdyz neuron moze skladac sie z kilku elementow
				if(scene.object[i].name.startsWith("Neuron"+markedNeuronShort+"_"))
				{
					String zmienna = (String)fram.getNeuroProp(Integer.valueOf(markedNeuronShort).intValue(),"d");
					//String zmienna = fram.getNeuroProp(markedNeuronShort,"d");
					if(zmienna.equals("G")) scene.object[i].setMaterial(new idx3d_Material(0xEEEEEE));//odznaczenie
					else if(zmienna.equals("T")) scene.object[i].setMaterial(new idx3d_Material(0x000000));
					else if(zmienna.equals("S")) scene.object[i].setMaterial(new idx3d_Material(0xFF5500));
					else if(zmienna.equals("@")) scene.object[i].setMaterial(new idx3d_Material(0xFF0000));
					else if(zmienna.equals("|")) scene.object[i].setMaterial(new idx3d_Material(0xFF0000));
					else scene.object[i].setMaterial(new idx3d_Material(0xEEEEE));
				}
			}
			for(int i=0; i<fram.getNeuroCount(); i++)//dla wszystkich neuronow
			{						   //sprawdzamy, czy jest polaczenie z naszym	
				for(int j=0; j<5; j++)
				{
					if(scene.object("Connection"+markedNeuronShort+":"+i+"_"+j)!=null)
					{	//odznaczenie wejsc
						scene.object("Connection"+markedNeuronShort+":"+i+"_"+j).setMaterial(bialy);
					}
					if(scene.object("Connection"+i+":"+markedNeuronShort+"_"+j)!=null)
					{	//odznaczenie wyjsc
						scene.object("Connection"+i+":"+markedNeuronShort+"_"+j).setMaterial(bialy);
					}
				}
			}
		}
		markedNeuron = obiekt.name;//scene.object(obj).name;
		markedNeuronShort = markedNeuron.substring(6,markedNeuron.length()-2);//numerek
		for(int i=0; i<scene.objects; i++)//sprawdzamy wszystkie obiekty sceny
		{//aby zaznaczyc wszystkie skladowe "wizerunku" zaznaczanego neuronu
			if(scene.object[i].name.startsWith("Neuron"+markedNeuronShort+"_"))
				scene.object[i].setMaterial(zielony);//odznaczenie
		}
		for(int i=0; i<fram.getNeuroCount(); i++)//dla wszystkich neuronow
		{
			for(int j=0; j<5; j++)
			{
				if(scene.object("Connection"+markedNeuronShort+":"+i+"_"+j)!=null)
				{	//zaznaczenie wejsc
					scene.object("Connection"+markedNeuronShort+":"+i+"_"+j).setMaterial(czerwony);
				}
				if(scene.object("Connection"+i+":"+markedNeuronShort+"_"+j)!=null)
				{	//zaznaczenie wyjsc
					scene.object("Connection"+i+":"+markedNeuronShort+"_"+j).setMaterial(zielony);
				}
			}
		}
		createDescription(markedNeuronShort);//opis slowny parametrow zaznaczonego neuronu
		scene.rebuild();					 //przebudowanie sceny
		//trial method
		//fram.fireSignificantEditEvent();
		//trial ends BLOKUJE PRZEBUDOWE SCENY!!! NIE WIDA? ZAZNACZENIA!!!
	}

	public void createDescription(String number)//tworzy opis slowny zaznaczonego neuronu
	{
		if(number==null) return;//just in case 
		description0 = "Neuron " + number + " ";//paramerty neuronu
		description1 = "In : ";					//wejscia
		description2 = "Out: ";					//oraz wyjscia
		int id = Integer.valueOf(number).intValue();//ktory neuron i na czym
		if (fram.neuroPropExists(id,"p")) description0 = description0 + "- Part " + fram.getNeuroProp(id,"p") + " :";
		if (fram.neuroPropExists(id,"j")) description0 = description0 + "- Joint " + fram.getNeuroProp(id,"j") + " :";
		for(int i=0; i<fram.getConnCount(); i++)//i jakie ma polaczenia
		{
			if (id==((Integer)fram.getConnProp(i,"n")).intValue())//do, czyli wejscia
			{
				description1 = description1 + fram.getConnProp(i,"i") + "(w=" + fram.getConnProp(i,"w") + "), ";
			}
			if (id==((Integer)fram.getConnProp(i,"i")).intValue())//od, czyli wyjscia
			{
				description2 = description2 + fram.getConnProp(i,"n") + "(w=" + fram.getConnProp(i,"w") + "), ";
			}	//opisy sie odpowiednio poszerzaja
		}
	}

	public void setAnimation()
	{
		if (animation) 
		{
			animation = false;
			zielony.setTransparency(0);
			czerwony.setTransparency(0);
			scene.setAntialias(true);
		}
		else 
		{
			animation = true;
			czerwony.setTransparency(125);
			zielony.setTransparency(125);
			scene.setAntialias(false);
		}
	}

	public String[] showProperties(int x, int y)//method
	{
		idx3d_Object obiekt = this.scene.identifyObjectAt(x,y);//id obiektu pod kursorem
		if(obiekt==null)
		{
			//description1 = "";
			//description2 = "";
			return null;
		}
		int id = -1;
		String typ = "unknown";
		if(obiekt.name.startsWith("Neuron"))
		{
			id = Integer.valueOf(obiekt.name.substring(6,obiekt.name.length()-2)).intValue();
			typ = "n";
		}
		else 
		{
			//description1 = "";
			//description2 = "";
			return null;
		}
		//description1 = "Properties of the element you clicked on.";
		//description2 = "Type: " + typ + "; Number: " + id;
		String[] s = {String.valueOf(id), typ};
		return s; 
	}
//-------------------------------------------------------------------------
//--i na koniec metody odpowiedzialne za wystepujace w applecie zdarzenia--
//-------------------------------------------------------------------------

	public void mousePressed(MouseEvent evt)//wcisniecie klawisza myszy
	{
		if(evt.getModifiers()==MouseEvent.BUTTON3_MASK) return;
		//jak chcemy propertisy, to nic innego nas nie interesuje :)
		oldx=evt.getPoint().x;					  //dla przesuniec	
		oldy=evt.getPoint().y;
		idx3d_Object obj = this.scene.identifyObjectAt(evt.getPoint().x,evt.getPoint().y);//id obiekty pod kursorem
		if (obj!=null && obj.name.startsWith("Neuron")) changeColors(obj);
	}
	
	public void mouseReleased(MouseEvent evt)//puszczenie klawisza
	{
		repaint();
	}

	public void mouseDragged(MouseEvent evt)//przeciagniecie myszy
	{
		lookAtX -= (evt.getPoint().x-oldx)/50;					//nowe wsp. patrzenia
		lookAtY += (evt.getPoint().y-oldy)/50;					//siec sie "przesuwa"
		scene.defaultCamera.setPos(lookAtX,lookAtY,-view);//ustawienie kamery
		scene.defaultCamera.lookAt(lookAtX,lookAtY,0);
		oldx=evt.getPoint().x;									//zapamietanie wsp.
		oldy=evt.getPoint().y;
	}

	public void mouseClicked(MouseEvent evt) {}
	public void mouseEntered(MouseEvent evt) {}
	public void mouseExited(MouseEvent evt) {}
	public void mouseMoved(MouseEvent evt) 
	{
		oldx=evt.getPoint().x;//zapamietanie wsp.
		oldy=evt.getPoint().y;
	}

	public void mouseWheelMoved(MouseWheelEvent evt)
	{
		if(evt.getWheelRotation()==-1) zoomOut();
		else zoomIn();
		repaint();
	}

	protected class MyFramstickListener implements FramstickListener
	{
		public void significantEdit(FramstickEvent framEvent)
		{
			redrawScene();
			repaint();
			System.out.println("Neuro: edit event !");
		}

		public void markChanged(FramstickEvent framEvent)
		{
			markedNeuron = null;
			description0 = "";			//3 linie do opisania zaznaczonego neuronu
			description1 = "";
			description2 = "";
			redrawScene();
			repaint();
			System.out.println("Neuro: mark event !");
		}
	}
	
	protected float getNeuroMin(int blok,String propname)
	{
	float mi=0;
	for(int i=0; i<fram.getNeuroCount(); i++)
		{
		if(((Integer)fram.getNeuroProp(i,"blok")).intValue()==blok)
			{
			float v=((Float)fram.getNeuroProp(i,propname)).floatValue();
			if(v<mi) mi=v;
			}
	    }
	return mi;
	}

	protected float getNeuroMax(int blok,String propname)
	{
	float ma=0;
	for(int i=0; i<fram.getNeuroCount(); i++)
		{
		if(((Integer)fram.getNeuroProp(i,"blok")).intValue()==blok)
			{
			float v=((Float)fram.getNeuroProp(i,propname)).floatValue();
			if(v>ma) ma=v;
			}
	    }
	return ma;
	}

	//--------------------------------------------------------------------------------------
//------------------------all the stuff required for sorting----------------------------
//--------------------------------------------------------------------------------------

	public void setAllNeurons()//ladne, posortowane
	{
		if(fram.getNeuroCount()==0) return;
		for(int i=0; i<fram.getNeuroCount(); i++)
		{
			fram.setNeuroProp(i,"x",new Float(0));//new Float(Float.POSITIVE_INFINITY));
			fram.setNeuroProp(i,"y",new Float(0));//new Float(Float.POSITIVE_INFINITY));
			fram.setNeuroProp(i,"blok",new Integer(Integer.MAX_VALUE));
		}
		int liczbaNeuronow = fram.getNeuroCount();
		int el;
		for(el=0; el<liczbaNeuronow; el++) ustawElement(el);
		int blok = -1;
		for(el=0; el<fram.getNeuroCount(); el++)
		{
			if(((Integer)fram.getNeuroProp(el,"blok")).intValue()==el) 
			{
				blok=el;
				el++;
				break;
			}
		}
		if(blok==-1) blok=0;
		for(;el<liczbaNeuronow;el++)
		{
		float bmix=getNeuroMin(blok, "x");
		float bmiy=getNeuroMin(blok, "y");
		float bmax=getNeuroMax(blok, "x");
		float bmay=getNeuroMax(blok, "y");
		if ((bmax-bmix)>(bmay-bmiy))
		    {
		    float y=bmay+2;
		    float x=bmix;
		    float ex=bmax;
		    for(;el<liczbaNeuronow;el++)
			{
			int numer = ((Integer)fram.getNeuroProp(el,"blok")).intValue();
			if(blok!=numer)
			    {
			    float nmix=getNeuroMin(numer, "x");
			    float nmiy=getNeuroMin(numer, "y");
			    float nmax=getNeuroMax(numer, "x");
			    float nmay=getNeuroMax(numer, "y");
			    float dx=nmax-nmix+2;
			    dolaczBlok(blok,numer,x-nmix,y-nmiy);
			    x+=dx;
			    if (x>ex) break;
			    }
			}
		    }
		else
		    {
		    float x=bmax+2;
		    float y=bmiy;
		    float ey=bmay;
		    for(;el<liczbaNeuronow;el++)
			{
			int numer = ((Integer)fram.getNeuroProp(el,"blok")).intValue();
			if(blok!=numer)
			    {
			    float nmix=getNeuroMin(numer, "x");
			    float nmiy=getNeuroMin(numer, "y");
			    float nmax=getNeuroMax(numer, "x");
			    float nmay=getNeuroMax(numer, "y");
			    float dy=nmay-nmiy+2;
			    dolaczBlok(blok,numer,x-nmix,y-nmiy);
			    y+=dy;
			    if (y>ey) break;
			    }
			}
		    }
		    
		    ////////////////////////////////////
		/*
		    	if ((first->maxx-first->minx)>(first->maxy-first->miny))
		{
		int y=first->maxy+2;
		int x=first->minx;
		int ex=first->maxx;
		while(el<N)
			{
			if (bloki[el])
				{
				int dx=bloki[el]->maxx-bloki[el]->minx+2;
				dolaczblok(first,bloki[el],x-bloki[el]->minx,y-bloki[el]->miny);
				x+=dx;
				if (x>ex) break;
				}
			el++;
			}
		}
	else
		{
		int x=first->maxx+2;
		int y=first->miny;
		int ey=first->maxy;
		while(el<N)
			{
			if (bloki[el])
				{
				int dy=bloki[el]->maxy-bloki[el]->miny+2;
				dolaczblok(first,bloki[el],x-bloki[el]->minx,y-bloki[el]->miny);
				y+=dy;
				if (y>ey) break;
				}
			el++;
			}
		}
		 */
		    ////////////////////////////////////
		    
		    
/*
			if(blok!=((Integer)fram.getNeuroProp(el,"blok")).intValue())
			{
				int numer = ((Integer)fram.getNeuroProp(el,"blok")).intValue();
				float blokminx = Float.POSITIVE_INFINITY;
				float numerminx= Float.POSITIVE_INFINITY;
				float numerminy = Float.POSITIVE_INFINITY;
				float blokmaxy = Float.NEGATIVE_INFINITY;
				for(int i=0; i<fram.getNeuroCount(); i++)
				{
					if(((Integer)fram.getNeuroProp(i,"blok")).intValue()==blok)
					{
						if(blokminx>((Float)fram.getNeuroProp(i,"x")).floatValue()) blokminx=((Float)fram.getNeuroProp(i,"x")).floatValue();
						if(blokmaxy<((Float)fram.getNeuroProp(i,"y")).floatValue()) blokmaxy=((Float)fram.getNeuroProp(i,"y")).floatValue();
					}
					if(((Integer)fram.getNeuroProp(i,"blok")).intValue()==numer)
					{
						if(numerminx>((Float)fram.getNeuroProp(i,"x")).floatValue()) numerminx=((Float)fram.getNeuroProp(i,"x")).floatValue();
						if(numerminy>((Float)fram.getNeuroProp(i,"y")).floatValue()) numerminy=((Float)fram.getNeuroProp(i,"y")).floatValue();
					}
				}
				dolaczBlok(blok,numer,blokminx-numerminx,blokmaxy-numerminy+1);
			}
 */
		}
	}



	boolean moznaDolaczyc(int /***/b, int /***/b2, float dx, float dy)
	{
		if(b==b2)return false;
		float bmaxx= Float.NEGATIVE_INFINITY;
		float bmaxy= Float.NEGATIVE_INFINITY;
		float b2maxx= Float.NEGATIVE_INFINITY;
		float b2maxy = Float.NEGATIVE_INFINITY;
		float bminx= Float.POSITIVE_INFINITY;
		float b2minx = Float.POSITIVE_INFINITY;
		float bminy = Float.POSITIVE_INFINITY;
		float b2miny = Float.POSITIVE_INFINITY;
		for(int i=0; i<fram.getNeuroCount(); i++)
		{
			if(((Integer)fram.getNeuroProp(i,"blok")).intValue()==b)
			{
				if(((Float)fram.getNeuroProp(i,"x")).floatValue()<bminx) bminx=((Float)fram.getNeuroProp(i,"x")).floatValue();
				if(((Float)fram.getNeuroProp(i,"y")).floatValue()<bminy) bminy=((Float)fram.getNeuroProp(i,"y")).floatValue();
				if(((Float)fram.getNeuroProp(i,"x")).floatValue()>bmaxx) bmaxx=((Float)fram.getNeuroProp(i,"x")).floatValue();
				if(((Float)fram.getNeuroProp(i,"y")).floatValue()>bmaxy) bmaxy=((Float)fram.getNeuroProp(i,"y")).floatValue();
			}
			if(((Integer)fram.getNeuroProp(i,"blok")).intValue()==b2)
			{
				if(((Float)fram.getNeuroProp(i,"x")).floatValue()<b2minx) b2minx=((Float)fram.getNeuroProp(i,"x")).floatValue();
				if(((Float)fram.getNeuroProp(i,"y")).floatValue()<b2miny) b2miny=((Float)fram.getNeuroProp(i,"y")).floatValue();
				if(((Float)fram.getNeuroProp(i,"x")).floatValue()>b2maxx) b2maxx=((Float)fram.getNeuroProp(i,"x")).floatValue();
				if(((Float)fram.getNeuroProp(i,"y")).floatValue()>b2maxy) b2maxy=((Float)fram.getNeuroProp(i,"y")).floatValue();
			}
		}
		float x1,x2,y1,y2;
		x1=Math.max(0,b2minx-bminx+dx);
		x2=Math.min(bmaxx-bminx,-bminx+dx+b2maxx);
		if(x1>x2) return true;
		y1=Math.max(0,b2miny-bminy+dy);
		y2=Math.min(bmaxy-bminy,-bminy+dy+b2maxy);
		if(y1>y2) return true;
		int x,y;
		dx+=b2minx-bminx;
		dy+=b2miny-bminy;
		int w = (int)bmaxx - (int)bminx + 1;
		int h = (int)bmaxy - (int)bminy + 1;
		float[] mapa = new float[w*h];
		for(int i=0; i<w*h; i++) mapa[i]=0;
		for(int i=0; i<fram.getNeuroCount(); i++)
		{
			if(((Integer)fram.getNeuroProp(i,"blok")).intValue()==b)
				mapa[w*(int)(((Float)fram.getNeuroProp(i,"y")).floatValue()-bminy)+(int)(((Float)fram.getNeuroProp(i,"x")).floatValue()-bminx)]=1;
		}
		int w2 = (int)b2maxx - (int)b2minx + 1;
		int h2 = (int)b2maxy - (int)b2miny + 1;
		float[] mapa2 = new float[w2*h2];
		for(int i=0; i<w2*h2; i++) mapa2[i]=0;
		for(int i=0; i<fram.getNeuroCount(); i++)
		{
			if(((Integer)fram.getNeuroProp(i,"blok")).intValue()==b2)
				mapa2[w2*(int)(((Float)fram.getNeuroProp(i,"y")).floatValue()-b2miny)+(int)(((Float)fram.getNeuroProp(i,"x")).floatValue()-b2minx)]=1;
		}
		for(y=(int)y1; y<=y2; y++)
		{
			for(x=(int)x1; x<=x2; x++)
			{
				if(mapa[w*y+x]==1 && mapa2[w2*(y-(int)dy)+(x-(int)dx)]==1) return false;
				
			}
		}
		return true;
	}

	boolean dolaczBlok(int b, int b2, float dx, float dy)
	{
		if(!moznaDolaczyc(b,b2,dx,dy)) return false;
		int i,e;
		for(i=0; i<fram.getNeuroCount(); i++)
		{
			if(((Integer)fram.getNeuroProp(i,"blok")).intValue()==b2)
			{
				fram.setNeuroProp(i,"blok",new Integer(b));
				fram.setNeuroProp(i,"x",new Float(((Float)fram.getNeuroProp(i,"x")).floatValue()+dx));
				fram.setNeuroProp(i,"y",new Float(((Float)fram.getNeuroProp(i,"y")).floatValue()+dy));
			}
		}
		return true;
	}

	void polaczJakoWejscie(int e, int e2)
	{
		int b,b2;
		b=((Integer)fram.getNeuroProp(e,"blok")).intValue();
		if(((Integer)fram.getNeuroProp(e2,"blok")).intValue()==Integer.MAX_VALUE)
			fram.setNeuroProp(e2,"blok",new Integer(e2));
		b2=((Integer)fram.getNeuroProp(e2,"blok")).intValue();
		if(b==b2) return;
		float dx,dy;
		dx=((Float)fram.getNeuroProp(e,"x")).floatValue()-((Float)fram.getNeuroProp(e2,"x")).floatValue();
		dy=((Float)fram.getNeuroProp(e,"y")).floatValue()-((Float)fram.getNeuroProp(e2,"y")).floatValue();
		if(dolaczBlok(b,b2,dx-1,dy)) return;
		int proba;
		for(proba=1;;proba++)
		{
			if(dolaczBlok(b,b2,dx-1,dy-proba)) return;
			if(dolaczBlok(b,b2,dx-1,dy+proba)) return;
		}
	}

	void ustawElement(int e)
	{
		if(((Integer)fram.getNeuroProp(e,"blok")).intValue()!=Integer.MAX_VALUE) return;
		fram.setNeuroProp(e,"blok",new Integer(e));
		int we;
		for(int i=0; i<fram.getConnCount(); i++)
		{
			if(((Integer)fram.getConnProp(i,"n")).intValue()!=e) continue;
			int e2 = ((Integer)fram.getConnProp(i,"i")).intValue();
			if((e2<0) || (e==e2)) continue;
			ustawElement(e2);
			polaczJakoWejscie(e,e2);
		}
	}
}