package fred;

import idx3d.idx3d_Light;
import idx3d.idx3d_Material;
import idx3d.idx3d_Math;
import idx3d.idx3d_Object;
import idx3d.idx3d_ObjectFactory;
import idx3d.idx3d_Scene;
import idx3d.idx3d_Texture;
import idx3d.idx3d_TextureFactory;
import idx3d.idx3d_Vector;
import idx3d.idx3d_Vertex;
import idx3d.idx3d_3ds_Importer;//dla plik?w 3ds

//import java.awt.Button;
import java.awt.Color;
import java.awt.Dimension;
//import java.awt.Event;
import java.awt.Graphics;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.event.MouseWheelListener;
import java.awt.event.MouseWheelEvent;
import javax.swing.JPanel;

import jGDK.Framstick;
import jGDK.Library;
import jGDK.Record;
import jGDK.FramstickListener;
import jGDK.FramstickEvent;

import java.util.Hashtable;
import jGDK.I18N;

import favi.Tazo;
/**
 * This class is responsible for organisms body visualisation.
 * It uses idx3d package designed by Peter Walser to create simple 3D scene.
 * dziedziczy po Tazo z favi i dodaje rysowanie symboli neuronow przy zaznaczonym elemencie
 * @author Marcin Jurkiewicz
 * @version 1.32
 */
public class Tazo2 extends Tazo
{
  //zbior obiektow na stale zamieszczonych w tazo, zawierajacy pliki 3ds
  //ma to na celu zapobiezenie ciaglemu importowi obiektow z 3ds przy kazdym
  //rysowaniu neuronu w 3d; zamiast ciaglego importowania dokonywac sie bedzie
  //szybkiego podstawienia z obiektu, do ktorego dokonano importu w kontruktorze
  //jak sie potem okazalo jest to niemozliwe, bo idx nadpisuje importy na biezaco...
  idx3d_Object neuron3dsG = null;
  idx3d_Object neuron3dsU = null;
  idx3d_Object neuron3dsT = null;
  idx3d_Object neuron3dsS = null;
  idx3d_Object neuron3dsbend = null;
  idx3d_Object neuron3dsM = null;
  
  public Tazo2(Framstick model)
  {super(model);}
  
  public void updateSceneForDescription(String type, int id, float posX, float posY, float posZ)
  {
    draw3DsObjects(type, id, posX, posY, posZ);
  }
  /**
   * Importing neuron images as 3DS files and putting it on the scene.
   */
  public void draw3DsObjects(String type, int id, float posX, float posY, float posZ)
  //metoda rozmieszcza neurony dla danego typu obiektu o podanym indeksie
  //wokol punktu srodka tego obiektu
  {
    String typ = null;
    //ile elementow jest na parcie lub joincie
    licznikNeuronow = 0;
    if(type.equals("p"))//rysyjemy neurony na parcie
    {
      for(int i=0; i<fram.getNeuroCount(); i++)//zliczamy neurony na parcie
      {
        if( ((Integer)fram.getNeuroProp(i,"p")).intValue() == id) licznikNeuronow++;
      }
      idx3d_Object neuroniki[] = new idx3d_Object[licznikNeuronow];
      //tworzymy tablice obiektow, zeby idx nie nadpisal importow
      for(int i=0; i<licznikNeuronow; i++)
        neuroniki[i] = null;
      int numerekWliczniku=0;//oznaczenie kolejnego wyszukanego w tablicy neuronow
      //neuronu lezacego na podanym jako parametr elemencie
      for(int i=0; i<fram.getNeuroCount(); i++)
      {
        if( ((Integer)fram.getNeuroProp(i,"p")).intValue() == id)
        {
          //kat, o jaki zostanie obrocony kolejny dodawany element na
          //okregu wokol punktu srodka (jest to dlugosc luku)
          float angle = numerekWliczniku*(float)(2*Math.PI/licznikNeuronow);
          typ = (String)fram.getNeuroProp(i,"d");
          //pobieramy typ neuronu, po czym w zaleznosci od niego
          //importujemy odpowiedni plik 3ds
          if(typ.equals("G"))
          {
            try
            {
              new idx3d_3ds_Importer().importFromStream(ClassLoader.getSystemResourceAsStream("3DS/neuro-G.3ds"),this.scene);
            }
            catch(Exception e)
            {
              System.out.println("Unable to download 3ds files!");
            }
            neuron3dsG = scene.object("cylinder");//podstawienie importu
            scene.removeObject("cylinder");//usuwamy import ze sceny
            neuron3dsG.setMaterial(new idx3d_Material(0xEEEEEE));//kolor
            neuron3dsG.scale(0.3f);//skalowanie dla proporcji
            neuron3dsG.name = "Neuron"+numerekWliczniku;//podanie tymczasowej nazwy
            neuroniki[numerekWliczniku] = neuron3dsG;//dodanie do tablicy obiektow
          }
          else if(typ.equals("@"))//j.w.
          {
            try
            {
              new idx3d_3ds_Importer().importFromStream(ClassLoader.getSystemResourceAsStream("3DS/neuro-@.3ds"),this.scene);
            }catch(Exception e)
            {
              System.out.println("Unable to download 3ds files!");
            }
            neuron3dsM= scene.object("line");
            scene.removeObject("line");
            neuron3dsM.setMaterial(new idx3d_Material(0xFF0000));
            neuron3dsM.scale(0.3f);
            neuron3dsM.rotate(0,idx3d_Math.pi/2,0);//zeby bylo frontem do obserwatora
            neuron3dsM.name = "Neuron"+numerekWliczniku;
            neuroniki[numerekWliczniku] = neuron3dsM;
          }
          else if(typ.equals("T"))
          {
            try
            {
              new idx3d_3ds_Importer().importFromStream(ClassLoader.getSystemResourceAsStream("3DS/neuro-T.3ds"),this.scene);
            }catch(Exception e)
            {
              System.out.println("Unable to download 3ds files!");
            }
            neuron3dsT = scene.object("closedline");
            scene.removeObject("closedline");
            neuron3dsT.setMaterial(new idx3d_Material(0x000000));
            neuron3dsT.scale(0.4f);
            neuron3dsT.rotate(0,0,-idx3d_Math.pi/2);//zeby byl pionowo
            neuron3dsT.name = "Neuron"+numerekWliczniku;
            neuroniki[numerekWliczniku] = neuron3dsT;
          }
          else if(typ.equals("S"))
          {
            try
            {
              new idx3d_3ds_Importer().importFromStream(ClassLoader.getSystemResourceAsStream("3DS/neuro-S.3ds"),this.scene);
            }catch(Exception e)
            {
              System.out.println("Unable to download 3ds files!");
            }
            neuron3dsS = scene.object("closedline");
            scene.removeObject("closedline");
            neuron3dsS.setMaterial(new idx3d_Material(0xFF5500));
            neuron3dsS.scale(0.5f);
            neuron3dsS.name = "Neuron"+numerekWliczniku;
            neuroniki[numerekWliczniku] = neuron3dsS;
          }
          else if(typ.equals("|"))
          {
            try
            {
              new idx3d_3ds_Importer().importFromStream(ClassLoader.getSystemResourceAsStream("3DS/neuro-bend.3ds"),this.scene);
            }catch(Exception e)
            {
              System.out.println("Unable to download 3ds files!");
            }
            neuron3dsbend = scene.object("line");
            scene.removeObject("line");
            neuron3dsbend.setMaterial(new idx3d_Material(0xFF0000));
            neuron3dsbend.scale(0.3f);
            neuron3dsbend.name = "Neuron"+numerekWliczniku;
            neuroniki[numerekWliczniku] = neuron3dsbend;
          }
          else
          {
            try
            {
              new idx3d_3ds_Importer().importFromStream(ClassLoader.getSystemResourceAsStream("3DS/neuro-U.3ds"),this.scene);
            }catch(Exception e)
            {
              System.out.println("Unable to download 3ds files!");
            }
            neuron3dsU = scene.object("box");
            scene.removeObject("box");//usuwamy import
            neuron3dsU.setMaterial(new idx3d_Material(0xEEEEE));
            neuron3dsU.scale(0.3f);
            neuron3dsU.name = "Neuron"+numerekWliczniku;
            neuroniki[numerekWliczniku] = neuron3dsU;
          }
          //dodanie elementu do sceny
          scene.addObject("Neuron"+i+"__",neuroniki[numerekWliczniku]);
          //jak zaznaczony to kolor
          if(fram.elementStrongSelected("n",i))
          {
            if(details) scene.object("Neuron"+i+"__").setMaterial(markedS);
            else scene.object("Neuron"+i+"__").setMaterial(markedS2);
          }
          //liczymy mase, zeby wiedziec, na jakim okregu rozmieszczac
          float masa = ((Float)fram.getPartProp(id,"m")).floatValue();
          //tu na podstawie masy liczymy promien okregu
          float r = 0.2f*(float)Math.pow(masa/0.1f,1f/3f)/3f+0.2f;
          //i nowe wspolrzedne
          float newX = posX + r*(float)Math.cos(angle);
          float newY = posY + r*(float)Math.sin(angle);
          float newZ = posZ - r;
          scene.object("Neuron"+i+"__").setPos(newX, newY, newZ);
          numerekWliczniku++;//kolejny neuron
        }
      }
    }
    else if(type.equals("j"))//rysujemy neurony na joincie (procedura j.w.
    {
      for(int i=0; i<fram.getNeuroCount(); i++)
      {
        if( ((Integer)fram.getNeuroProp(i,"j")).intValue() == id) licznikNeuronow++;
      }
      idx3d_Object neuroniki[] = new idx3d_Object[licznikNeuronow];
      for(int i=0; i<licznikNeuronow; i++)
        neuroniki[i] = null;
      int numerekWliczniku=0;
      for(int i=0; i<fram.getNeuroCount(); i++)
      {
        if( ((Integer)fram.getNeuroProp(i,"j")).intValue() == id)
        {
          float angle = numerekWliczniku*(float)(2*Math.PI/licznikNeuronow);
          typ = (String)fram.getNeuroProp(i,"d");
          if(typ.equals("G"))
          {
            try
            {
              new idx3d_3ds_Importer().importFromStream(ClassLoader.getSystemResourceAsStream("3DS/neuro-G.3ds"),this.scene);
            }
            catch(Exception e)
            {
              System.out.println("Unable to download 3ds files!");
            }
            neuron3dsG = scene.object("cylinder");
            scene.removeObject("cylinder");
            neuron3dsG.setMaterial(new idx3d_Material(0xEEEEEE));
            neuron3dsG.scale(0.3f);
            neuron3dsG.name = "Neuron"+numerekWliczniku;
            neuroniki[numerekWliczniku] = neuron3dsG;
          }
          else if(typ.equals("@"))
          {
            try
            {
              new idx3d_3ds_Importer().importFromStream(ClassLoader.getSystemResourceAsStream("3DS/neuro-@.3ds"),this.scene);
            }catch(Exception e)
            {
              System.out.println("Unable to download 3ds files!");
            }
            neuron3dsM= scene.object("line");
            scene.removeObject("line");
            neuron3dsM.setMaterial(new idx3d_Material(0xFF0000));
            neuron3dsM.scale(0.3f);
            neuron3dsM.rotate(0,idx3d_Math.pi/2,0);//zeby byl frontem do usera
            neuron3dsM.name = "Neuron"+numerekWliczniku;
            neuroniki[numerekWliczniku] = neuron3dsM;
          }
          else if(typ.equals("T"))
          {
            try
            {
              new idx3d_3ds_Importer().importFromStream(ClassLoader.getSystemResourceAsStream("3DS/neuro-T.3ds"),this.scene);
            }catch(Exception e)
            {
              System.out.println("Unable to download 3ds files!");
            }
            neuron3dsT = scene.object("closedline");
            scene.removeObject("closedline");
            neuron3dsT.setMaterial(new idx3d_Material(0x000000));
            neuron3dsT.scale(0.5f);
            neuron3dsT.rotate(0,0,-idx3d_Math.pi/2);//zeby byl pionowo
            neuron3dsT.name = "Neuron"+numerekWliczniku;
            neuroniki[numerekWliczniku] = neuron3dsT;
          }
          else if(typ.equals("S"))
          {
            try
            {
              new idx3d_3ds_Importer().importFromStream(ClassLoader.getSystemResourceAsStream("3DS/neuro-S.3ds"),this.scene);
            }catch(Exception e)
            {
              System.out.println("Unable to download 3ds files!");
            }
            neuron3dsS = scene.object("closedline");
            scene.removeObject("closedline");
            neuron3dsS.setMaterial(new idx3d_Material(0xFF5500));
            neuron3dsS.scale(0.5f);
            neuron3dsS.name = "Neuron"+numerekWliczniku;
            neuroniki[numerekWliczniku] = neuron3dsS;
          }
          else if(typ.equals("|"))
          {
            try
            {
              new idx3d_3ds_Importer().importFromStream(ClassLoader.getSystemResourceAsStream("3DS/neuro-bend.3ds"),this.scene);
            }catch(Exception e)
            {
              System.out.println("Unable to download 3ds files!");
            }
            neuron3dsbend = scene.object("line");
            scene.removeObject("line");
            neuron3dsbend.setMaterial(new idx3d_Material(0xFF0000));
            neuron3dsbend.scale(0.3f);
            neuron3dsbend.name = "Neuron"+numerekWliczniku;
            neuroniki[numerekWliczniku] = neuron3dsbend;
          }
          else
          {
            try
            {
              new idx3d_3ds_Importer().importFromStream(ClassLoader.getSystemResourceAsStream("3DS/neuro-U.3ds"),this.scene);
            }catch(Exception e)
            {
              System.out.println("Unable to download 3ds files!");
            }
            neuron3dsU = scene.object("box");
            scene.removeObject("box");//usuwamy import
            neuron3dsU.setMaterial(new idx3d_Material(0xEEEEE));
            neuron3dsU.scale(0.3f);
            neuron3dsU.name = "Neuron"+numerekWliczniku;
            neuroniki[numerekWliczniku] = neuron3dsU;
          }
          scene.addObject("Neuron"+i+"__",neuroniki[numerekWliczniku]);
          if(fram.elementStrongSelected("n",i))
          {
            if(details) scene.object("Neuron"+i+"__").setMaterial(markedS);
            else scene.object("Neuron"+i+"__").setMaterial(markedS2);
          }
          float r = 0.3f;//tu musi byc stala wartosc, bo Jointy nie maja masy
          float newX = posX + r*(float)Math.cos(angle);
          float newY = posY + r*(float)Math.sin(angle);
          float newZ = posZ - r;
          scene.object("Neuron"+i+"__").setPos(newX, newY, newZ);
          numerekWliczniku++;
        }
      }
    }
  }
  
}