package jGDK;

import java.util.*;

/**
 * <p>Title: Fred v.2.0 - ErrManager.java</p>
 * @author Piotr Jankowski, Cezary Dowhan
 * @version 2.0
 */

public class ErrManager 
{
	public static final int ER_WARNING	= 0;
	public static final int ER_HINT		= 1;
	public static final int ER_MESSAGE	= 2;
	public static final int ER_ERROR	= 3;

	static boolean initialized;	// wskazuje czy istnieje jakis obiekt tej klasy
	static public  Vector msg;	// wektor gromadzacy komunikaty do wyswietlenia

// constructor ----------------------------------------------------------

	/**	Tworzy obiekt klasy ErrManager. Po jego utworzeniu wszelkie komunikaty
	 *	nie beda juz bezposrednio kierowane na standardowe wyjscie.
	 */
	
	public ErrManager()
	{
		msg  = new Vector();
		initialized = true;
	}

	//the end of initial section --------------------------------------

	/**	Statyczna metoda pozwalajca na przekierowanie strumienia komunikatow
	 *  na standardowe wyjscie w przypadku, gdy nie istnieje obiekt tejze klasy.
	 *	W przeciwnym wypadku komunikaty sa gromadzone w wektorze, skad moga byc
	 *  pobrane i wyswietlone.
	 */

	public static void send(int code, String announcement)
	{
		if (!initialized) {
			System.out.println(announcement);
			return;
		}

		msg.add(new Message(code, announcement));
	}
	
	public static void send(String source, int code, String announcement)
	{
		if (!initialized) {
			System.out.println(announcement);
			return;
		}

		msg.add(new Message(source, code, announcement));
	}


};