package jGDK;

import java.util.Vector;

/**
 * <p>Title: Fred v.2.0 - GenFileParser.java</p>
 * @author Cezary Dowhan
 * @version 2.0
 */

public class GenFileParser extends F0Automaton
{
	public Vector framsticksSet;
	public int    numberOfFramsticks;

// constructor ----------------------------------------------------------

	public GenFileParser(String genFile)
	{
		super(genFile);
		framsticksSet = new Vector();
		numberOfFramsticks = getFramsticks();
	}

	protected void addTokenizerSettings()	// Adapter
	{
		st.commentChar('#'); //additional StreamTokenizer setting
	}

	//the end of initial section --------------------------------------

	private int getFramsticks()
	{
		Framstick framstick = new Framstick();
		boolean orgClass = false;

		while (nextToken() != ID_EOF) 
		{
			switch (tokenMaster.type)
			{
			case ID_EOL: continue;
			case ID_CLASS:
				String idClass = (String) tokenMaster.data;
				if (idClass.equals("org")) {
					framstick = new Framstick();
					framsticksSet.addElement(framstick);
					orgClass = true;
					skipLine();
					continue;
				}
				String classBody = getSection();
				if (orgClass == true) {
					if (idClass.equals("name"))	 { framstick.name	= classBody; continue; }		
					if (idClass.equals("author")){ framstick.author = classBody; continue; }		
					if (idClass.equals("info"))	 { framstick.info	= classBody; continue; }
					if (idClass.equals("genotype")) { framstick.genotype = classBody; continue; }
				}
				orgClass = false; // encounter unknown class
				continue;
			default:
				ErrManager.send(ErrManager.ER_ERROR, "Syntax error in line "+lineNo+". Class definition expected.");
				skipLine();
			}
		}
		return framsticksSet.size();
	}
// the end of private method: getFramstickSet() ------------------------------------
};