package jGDK;

/** orientation in 3d space = rotation matrix */
public class Orient3d
{
	public float m[];
	public Orient3d()
	{
		reset();
	}

	public Orient3d(Orient3d o)
	{
		m=new float[9];
		for(int i=0;i<9;i++)
		m[i]=o.m[i];
	}

	public void reset()
	{
		m=new float[]{1,0,0,0,1,0,0,0,1};
	}


	private void rot2D(float s,float c,int xi,int yi)
	{
		float t=c*m[xi]-s*m[yi];
		m[yi]=s*m[xi]+c*m[yi];
		m[xi]=t;
	}

	public void rotate(float x,float y,float z)
	{
		float s,c;
		if (x!=0)
		{
			s=(float)Math.sin(x); c=(float)Math.cos(x);
			rot2D(s,c,1,2);
			rot2D(s,c,4,5);
			rot2D(s,c,7,8);
		}

		if (y!=0)
		{
			s=(float)Math.sin(y); c=(float)Math.cos(y);
			rot2D(s,c,0,2);
			rot2D(s,c,3,5);
			rot2D(s,c,6,8);
		}

		if (z!=0)
		{
			s=(float)Math.sin(z); c=(float)Math.cos(z);
			rot2D(s,c,0,1);
			rot2D(s,c,3,4);
			rot2D(s,c,6,7);
		}
	
	}


	public float[] transform(float xyz[])
	{
		float ret[]=new float[xyz.length];
		transform(ret,xyz);
		return ret;
	}


	public void transform(float target_xyz[],float xyz[])
	{
		for(int i=0;i<xyz.length;i+=3)
		{
		target_xyz[i+0]=xyz[i+0]*m[0]+xyz[i+1]*m[3]+xyz[i+2]*m[6];
		target_xyz[i+1]=xyz[i+0]*m[1]+xyz[i+1]*m[4]+xyz[i+2]*m[7];
		target_xyz[i+2]=xyz[i+0]*m[2]+xyz[i+1]*m[5]+xyz[i+2]*m[8];
		}
	}
}
