package jGDK;

import java.util.*;
/**
 * <p>Title: Fred v.2.0 - Part.java</p>
 * @author Piotr Jankowski
 * @version 2.0
 */

public class Part extends Element
{
	Hashtable properties;
  	Hashtable	pos;
  	Orient3d o;
	boolean parent=false; 
	boolean child=false;
	
	Part(Hashtable brandnew) 
	{
		this.properties= new Hashtable(brandnew);
		this.pos=new Hashtable();
		this.o=new Orient3d();
	}

	Part(Part n) 
	{
	
		this.properties = new Hashtable(n.properties);
		this.o=new Orient3d(n.o);
	}

	public String toString()
	{
		String ret = new String("p:"); 	
		Enumeration k = this.properties.keys();
		Enumeration e = this.properties.elements();
		while(k.hasMoreElements())
			ret +=k.nextElement()+"="+e.nextElement()+",";
		if (ret.length()==2) return ret;
    	else
      	return ret.substring(0,ret.length()-1);
	}
	
	/**
   	* calculates local system of coordinates of Part
  	*/
	public void setOrientation()
	{
		o.reset();
		float rX=0;
		float rY=0;
		float rZ=0;
		if (properties.containsKey("rx")) rX = ((Float)properties.get("rx")).floatValue();
		if (properties.containsKey("ry")) rY = ((Float)properties.get("ry")).floatValue();
		if (properties.containsKey("rz")) rZ = ((Float)properties.get("rz")).floatValue();
		o.rotate(rX,rY,rZ);
}

}